#include "stdafx.h"
#include <stdlib.h>
#include "defines.h"
#include "xy.h"
#include "xyz.h"
#include "images.h"
#include "mesh.h"
typedef uns char byte;
byte ntitap=1,showbadedges=0,fileopen=0;
/*-----*/
void setmem(void*a,int n,char c){int i; for(i=0;i<n;i++) ((char*)a)[i]=c;}
/*-----*/
double xyangle(xyz a,xyz b,xyz c){double A=(b-c).r(),B=(c-a).r(),C=(a-b).r(),D;
return!B?0:!C?0:(D=(B*B+C*C-A*A)/2/B/C,acos(D<-1?-1:D>1?1:D));}
/*-----*/
void mesh::DUMP(char*fn){FILE*F=fopen(fn,"w"); int i;
fprintf(F,"fac: %p: ",fac);
for(i=0;i<nf;i++) fprintf(F,"%2d: %p=%2d (%d)/",i,fac[i].q,fac[i].q-pts,fac[i].n); fprintf(F,"\n");
fprintf(F,"pts: %p: ",pts);
for(i=0;i<nq;i++) fprintf(F,"%2d: %p=%2d /",i,pts[i].p,pts[i].p-point); fprintf(F,"\n");
fprintf(F,"points: %p: ",pts);
for(i=0;i<np;i++) fprintf(F,"%2d: {%g,%g,%g} /",i,point[i].a.x,point[i].a.y,point[i].a.z);
fprintf(F,"\n"); fclose(F);}
/*-----*/
#define det3(A,B,C,D,E,F,G,H,I) (A*(E*I-H*F)+D*(H*C-B*I)+G*(B*F-E*C))
/*-----*/
//double eqnsolve2(double ax,double ay,double bx,double by,double a,double b,
//  double&A,double&B){double det; if((det=ax*by-bx*ay)==0) return det;
//A=(by*a-ay*b)/det; B=(ax*b-bx*a)/det; return det; }
/*-----*/
#if 0
void eqnsolve34(double ax,double ay,double az,double a,
                double bx,double by,double bz,double b,
                double cx,double cy,double cz,double c,
                double &A,double &B,double &C,double&det){
det=det3(az,ax,ay,bz,bx,by,cz,cx,cy);
A  =det3(a ,ay,az,b ,by,bz,c ,cy,cz);
B  =det3(ax,a ,az,bx,b ,bz,cx,c ,cz);
C  =det3(ax,ay,a ,bx,by,b ,cx,cy,c );}
/*-----*/
double eqnsolve3(double ax,double ay,double az,double a,
                 double bx,double by,double bz,double b,
                 double cx,double cy,double cz,double c,
					  double &A,double &B,double &C){double  det;
if(det=det3(az,ax,ay,bz,bx,by,cz,cx,cy),det*det<1e-40) return 0;
     A=det3(a ,ay,az,b ,by,bz,c ,cy,cz)/det;
     B=det3(ax,a ,az,bx,b ,bz,cx,c ,cz)/det;
	  C=det3(ax,ay,a ,bx,by,b ,cx,cy,c )/det; return det;}
#endif
/*-----*//* the device context dc must still be there when the pen is deleted */
PEN::PEN(HDC dc,COLORREF col){d=dc; pen=(HPEN)CreatePen(0,1,col); old=(HPEN)SelectObject(dc,pen);};
PEN::~PEN(){SelectObject(d,old); DeleteObject(pen);};
//*********/extern FILE*DEB;
/*-----*/
void SetTitle(HWND wn,char*S){
//*-----*/if(DEB) fprintf(DEB,"settext %16lx\n",(long)S); fflush(DEB);
SendMessage(wn,WM_SETTEXT,0,(long)S);}
/*-----*/
void GetTitle(HWND wn,char*S,long n){
//*-----*/if(DEB) fprintf(DEB,"gettext %16lx\n",(long)S); fflush(DEB);
SendMessage(wn,WM_GETTEXT,n,(long)S);}
/*-----*/
void message(HWND wn,char*S){HDC dc=GetDC(wn); HFONT f=CreateFont(12,0,0,0,700,0,0,0,ANSI_CHARSET,0,0,0,FF_ROMAN,0);
TextOut(dc,0,12,S,strlen(S)); DeleteObject(f); ReleaseDC(wn,dc);}
/*-----*/
double xb,yb,zb,xs,ys,zs; /* how to scale objects to current viewpoint */
double Sx,Sy,Sz,Cx,Cy,Cz; /* sin & cos of rotation angles */
double ub,vb,us,vs; /* how to scale texture map display */
int hite,wide; char scaled=0,texscaled=0,showall=0,showpts=0,rerot=1;
xyz Llm,Ulm,llm,ulm; /* limits of what to display */
xyz rotation,offset,screenmid(0,0,0); /* camera info */
xy texLlm,texUlm,texllm,texulm; /* limits of what to display */
xy texaxle; /* re rotating texture map parts */
/*-----*/
xyz rotate(xyz W){double w;
w=Cx*W.y-Sx*W.z; W.z=Sx*W.y+Cx*W.z; W.y=w;
w=Cy*W.z-Sy*W.x; W.x=Sy*W.z+Cy*W.x; W.z=w;
w=Cz*W.x-Sz*W.y; W.y=Sz*W.x+Cz*W.y; W.x=-w; return W;}
/*-----*/
xyz unrotate(xyz W){double w; W.x=-W.x; /* to cure the mirror-image fault */
w=Cz*W.x+Sz*W.y; W.y=-Sz*W.x+Cz*W.y; W.x=w;
w=Cy*W.z+Sy*W.x; W.x=-Sy*W.z+Cy*W.x; W.z=w;
w=Cx*W.y+Sx*W.z; W.z=-Sx*W.y+Cx*W.z; W.y=w; return W;}
/*-----*/
inline xyz revx(xyz w){return xyz(-w.x,w.y,w.z);}
/*-----*/
xyz scale(xyz W){W=  W-revx(offset); return xyz(W.x*xs+xb,hite-(W.y*ys+yb),W.z*zs+zb);}
xyz toscr(xyz W){W=rotate(W-offset); return xyz(W.x*xs+xb,hite-(W.y*ys+yb),W.z*zs+zb);}
xyz unscale(xyz W){return xyz((W.x-xb)/xs,(hite-W.y-yb)/ys,(W.z-zb)/zs)+revx(offset);};
xyz fromscr(xyz W){xyz Z((W.x-xb)/xs,(hite-W.y-yb)/ys,(W.z-zb)/zs); return unrotate(Z)+offset;};
/*-----*/
xy texscale(xy W){return xy(W.x*us+ub,W.y*vs*txyratio+vb);} /* VT values to pixels */
xy untexscale(xy W){W=xy((W.x-ub)/us,(W.y-vb)/(vs*txyratio)); return W;}; /* pixels to VT values */
/*-----*/
void Linexy(HDC dc,xyz A,xyz B){xyz C; if(showall) goto X; if(A.z>B.z) {C=A; A=B; B=C;}
if(B.z<llm.z ?1: A.z>ulm.z) return;
if(A.z<llm.z) A=(A*(B.z-llm.z)+B*(llm.z-A.z))*(1/(B.z-A.z));
if(B.z>ulm.z) B=(B*(A.z-ulm.z)+A*(ulm.z-B.z))*(1/(A.z-B.z));
X: MoveToEx(dc,(int)A.x,(int)A.y,0); LineTo(dc,(int)B.x,(int)B.y);}
/*-----*/
void Linezy(HDC dc,xyz A,xyz B){xyz C; if(showall) goto X; if(A.x>B.x) {C=A; A=B; B=C;}
if(B.x<llm.x ?1: A.x>ulm.x) return;
if(A.x<llm.x) A=(A*(B.x-llm.x)+B*(llm.x-A.x))*(1/(B.x-A.x));
if(B.x>ulm.x) B=(B*(A.x-ulm.x)+A*(ulm.x-B.x))*(1/(A.x-B.x));
X: MoveToEx(dc,(int)A.z,(int)A.y,0); LineTo(dc,(int)B.z,(int)B.y);}
/*-----*/
void Linetex(HDC dc,xy a,xy b){
a=texscale(a); b=texscale(b); MoveToEx(dc,(int)a.x,(int)a.y,0); LineTo(dc,(int)b.x,(int)b.y);}
/*-----*/
void Linetex(HDC dc,Texp*A,Texp*B){xy a=A?A->a:xy(0,0),b=B?B->a:xy(0,0);
a=texscale(a); b=texscale(b); MoveToEx(dc,(int)a.x,(int)a.y,0); LineTo(dc,(int)b.x,(int)b.y);}
/*-----*/
inline void insimag(HDC dc,image&I,int x,int y){SetDIBitsToDevice(dc,x,y,I.X,I.Y,0,0,0,I.Y,I.P,(BITMAPINFO*)&I.size,DIB_RGB_COLORS);}
/*-----*/
#define dot_col(c) if(dotcol!=c) {DOT(0)[0]=DOT(0)[1]=DOT(0)[2]=DOT(1)[0]=DOT(1)[1]=DOT(1)[2]=DOT(2)[0]=DOT(2)[1]=DOT(2)[2]=c; dotcol=c;}
#define dot_col(c) if(dotcol!=c) {DOT(0)[0]=DOT(0)[1]=DOT(0)[2]=DOT(1)[0]=DOT(1)[1]=DOT(1)[2]=DOT(2)[0]=DOT(2)[1]=DOT(2)[2]=c; dotcol=c;}
void Point::draw(HDC dc,byte xy,COLORREF c,int n){/*int i,j;*/ pal3 p((c>>16)&255,(c>>8)&255,(c>>0)&255);
//for(i=1-n;i<n;i++) for(j=1-n;j<n;j++) SetPixel(dc,(int)(xy?r.x:r.z)+i,(int)r.y+j,c);
//SetDIBitsToDevice(dc,(int)(xy?r.x:r.z)-1,(int)r.y-1,DOT.X,DOT.Y,0,0,0,DOT.Y,DOT.P,(BITMAPINFO*)&DOT.size,DIB_RGB_COLORS);
dot_col(c); insimag(dc,DOT,(int)(xy?r.x:r.z)-1,(int)r.y-1);};
/*-----*/
void draw(xy t,HDC dc,COLORREF c,int n){dot_col(c); insimag(dc,DOT,(int)t.x,(int)t.y);};
/*-----*/
void texdraw(HDC dc,xy T,COLORREF c,int n){dot_col(c); insimag(dc,DOT,(int)T.x-1,(int)T.y-1);};
/*-----*/
//double angle(xyz a,xyz b,xyz c){double ab=(a-b).r(),bc=(b-c).r(),ca=(c-a).r(),w; if(!ab?1:!bc) return 0;
//w=(ab*ab+bc*bc-ca*ca)/(2*ab*bc); return w>1?0:w<-1?pi:acos(w);}
/*-----*/
void fcinfo::texdraw(HDC dc,COLORREF c,int n){if(t) {xy T=texscale(t->a); ::texdraw(dc,T,c,n);}}
/*-----*/
xyz Face::midr(){long k; xyz W(0,0,0); for(k=0;k<n;k++) W=W+q[k].p->r; return n?W/n:W;}
/*-----*/
xyz Face::edgemidr(int i){return !q?xyz(0,0,0):(q[i].p->r+q[(i+1)%n].p->r)*.5;}
/*-----*/
xy Face::midrtex(){long k; xy W(0,0); Texp*t; for(k=0;k<n;k++) if(t=q[k].t,t) W=W+t->a; return W/n;}
/*-----*/
int Face::inbox(){xyz W=midr();
return W.x<llm.x ?0: W.x>ulm.x ?0: W.y<llm.y ?0: W.y>ulm.y ?0: W.z<llm.z ?0: W.z<=ulm.z;}
/*-----*/
int mesh::gm(Face*F){switch(disselgm){
case 'G': return group[F->g].vis;
case 'M': return mat[F->mat].vis;
default: return 1;}}
/*-----*/
void Face::draw(HDC dc,byte xy,int we){
fcinfo*F=q; if(!F) return; long j,m=n; xyz*vn;
if(we<0) for(j=0;j<m;j++) (xy?Linexy:Linezy)(dc,F[j].p->r,F[j==m-1?0:j+1].p->r);
else if(we<0?0:we<m) (xy?Linexy:Linezy)(dc,F[we].p->r,F[we==m-1?0:we+1].p->r);
if(showvn) if(we<0) for(j=0;j<m;j++) {
    vn=F[j].d; if(vn) (xy?Linexy:Linezy) (dc,F[j].p->r,toscr(F[j].p->a+*vn));}}
/*-----*/// on texture map, draw e'th edge of face :: all edges if e<0
void Face::texdraw(HDC dc,int e){fcinfo*F=q; if(!F) return; long j,m=n;
if(e<0) for(j=0;j<m;j++) Linetex(dc,F[j].t,F[(j+1)%m].t);
else if(e<m)             Linetex(dc,F[e].t,F[(e+1)%m].t);}
/*-----*/// select all vertexes which are corners of this face
void Face::selcorn(){if(!q)return; Face*F=this; fcinfo*I=q,*V,*VL; forvert() I->p->s=1;}
/*-----*/// select all vertexes which are corners of selected faces
void mesh::selcorn(){Face*F,*FL; fcinfo*I,*V,*VL; int i; for(i=0;i<np;i++) point[i].s=0;
forface() forvert() V->p->s=1;}
/*-----*/// select all texture map points which are at corners of selected faces
void mesh::seltex(){Face*F,*FL; fcinfo*I,*V,*VL; int i; for(i=0;i<nt;i++) t[i].s=0;
forface() if(gm(F)) forvert() if(V->t) V->t->s=1;}
/*-----*/
void Group::rename(char*s){strncpy(name,s,NML); name[NML-1]=0;}
/*-----*/
void Mat::rename(char*s){strncpy(name,s,NML); name[NML-1]=0;}
/*-----*/
mesh*OB=0; HWND Wn=0; long pdragging=-1;
/*-----*/
#define badaddr(p) (!IsValidAddress((char*)(p)))
int IsValidAddress(char*Ptr) {if(!Ptr) return 0;
try {volatile char c=*Ptr; *Ptr=c; return 1;} catch (...) {return 0;}}
/*-----*/
#define badnz(p) (!IsValidAddressOrZero((char*)(p)))
int IsValidAddressOrZero(char*Ptr) {if(!Ptr) return 1;
try {volatile char c=*Ptr; *Ptr=c; return 1;} catch (...) {return 0;}}
/*-----*/
static char Schk[128];
static char*chk(int i,int s,int n,char*name){
if(i%s) {sprintf(Schk,"%s bad, = (as bytes) %d, not a multiple of %d",name,i,s); return Schk;} i/=s;
if(i<0?1:i>=n) {sprintf(Schk,"%s = %d out of range, should be 0 to %d",name,i,n-1); return Schk;}
return 0;}
/*-----*/
char*mesh::check(){int j; Face*F,*FL; fcinfo*V,*VL,*I; char*s; //static char T[64];
//if(badnz(point )) return "bad-point" ; if(badnz(point +np_-1)) return "bad-point: too short";
//if(badnz(pts   )) return "bad-pts"   ; if(badnz(pts   +nq_-1)) return "bad-pts: too short";
//if(badnz(fac   )) return "bad-fac"   ; if(badnz(fac   +nf_-1)) return "bad-fac: too short";
//if(badnz(group )) return "bad-group" ; if(badnz(group +ng_-1)) return "bad-group: too short";
//if(badnz(tma   )) return "bad-tma"   ; if(badnz(tma +ntma_-1)) return "bad-tma: too short";
//if(badnz(mat   )) return "bad-mat"   ; if(badnz(mat +nmat_-1)) return "bad-mat: too short";
//if(badnz(prt   )) return "bad-prt"   ; if(badnz(prt +nprt_-1)) return "bad-prt: too short";
//for(i=0;i<nf;i++) if(I=fac[i].q,I) if(badnz(I)?1:badnz(((char*)I)+sizeof(fcinfo)-1)) {
//      sprintf(T,"bad fac[%d].q"); return T;}
s=chk(np  ,1,np_  +1,"OB.np"  ); if(s) return s;
s=chk(nq  ,1,nq_  +1,"OB.nq"  ); if(s) return s;
s=chk(nf  ,1,nf_  +1,"OB.nf"  ); if(s) return s;
s=chk(nt  ,1,nt_  +1,"OB.nt"  ); if(s) return s;
s=chk(nd  ,1,nd_  +1,"OB.nd"  ); if(s) return s;
s=chk(nmat,1,nmat_+1,"OB.nmat"); if(s) return s;
s=chk(ntma,1,ntma_+1,"OB.ntma"); if(s) return s;
forallface() {
	j=(char*)I-(char*)pts; s=chk(j,sizeof(fcinfo),nq,"fac.q"); if(s) return s;
	j=I-pts; s=chk(j+F->n,1,nq+1,"fac.n"); if(s) return s;
	forvert() {
		 if(V<pts?1:V>=pts+nq) {F->q=0; break;} //return "V out of range";
		 if(V->t) {s=chk((char*)V->t-(char*)t    ,sizeof(Texp ),nt,"q.t"); if(s) return s;}
		 if(V->d) {s=chk((char*)V->d-(char*)d    ,sizeof(xyz  ),nd,"q.d"); if(s) return s;}
		 if(!V->p) return "V->p==0"; s=chk((char*)V->p-(char*)point,sizeof(Point),np,"q.p"); if(s) return s;}
	s=chk(F->mat,1,nmat,"fac.mat"); if(s) return s;
	s=chk(F->tma,1,ntma,"fac.tma"); if(s) return s;
	s=chk(F->g  ,1,ng  ,"fac.g"  ); if(s) return s;
	s=chk(F->prt,1,nprt,"fac.prt"); if(s) return s;
	}
return 0;}
/*-----*/
mesh::mesh(){initialize();}
/*-----*/
void mesh::initialize(int j){if(j) delarrays();
setmem(this,sizeof(mesh),0); selface=selpoint=seltexp=-1;};
/*-----*/
void mesh::delarrays(){altered=1;
FF(fac); FF(point); FF(pts); FF(mat); FF(d); FF(t); FF(tma); FF(prt); FF(mtllib);}
/*-----*/
void*FMC[0x40000]; long nFMC=0;
/*-----*/
void far*Farmalloc(unsigned long n){register void*w; void far*q; long i,j/*,k=nFMC*/;
if(!(nFMC&0xfff)) {for(j=i=0;i<nFMC;i++) if(w=FMC[i],w) {if(i!=j) FMC[j]=w; j++;} nFMC=j;} // pack the table
//FILE*F=fopen("c:\\3d\\makeobj\\_debug.cpp","a");
//fprintf(F,"farmalloc wanted %5d bytes; that makes %d = 0x%x blocks, was %d.\n",n,nFMC,nFMC,k);
//fclose(F);
if(nFMC>=0x40000) {MessageBox(0,"too many store allocations at once","farmalloc",OUCH); q=0;}
else {q=malloc(n); FMC[nFMC++]=q;}
if(!q) if(n) MessageBox(0,"I can't get enough memory","farmalloc",OUCH); return q;}
/*-----*/
void far*Farrealloc(void *p,unsigned long n,char*name){void far*q; register long i; static char S[64];
if(!p) return Farmalloc(n);
//FILE*F=fopen("c:\\3d\\makeobj\\_debug.cpp","a");
//fprintf(F,"farrealloc wanted %5d bytes; that makes %d blocks.\n",n,nFMC);
//fclose(F);
for(i=0;i<nFMC;i++) if(p==FMC[i]) goto X; sprintf(S,"nFMC=%d, n=%d",nFMC,n);
MessageBox(0,"you tried to realloc memory which had not been allocated",S,OUCH); return 0;
X: q=realloc(p,n); FMC[i]=q;
if(!q) if(n) MessageBox(0,"I can't get enough memory",name?name:"an array",OUCH); return q;}
/*-----*/
void FFF(void**x) {register long i; register void*y=*x; if(!y) return; static char S[64];
for(i=0;i<nFMC;i++) if((void*)y==FMC[i]) {free(*x); *x=0; FMC[i]=0; return;}
sprintf(S,"nFMC=%d",nFMC); MessageBox(0,"you tried to free memory which had not been allocated",S,OUCH);}
/*-----*/
static char*nspac="I ran out of space when wanting more room for ";
#define MIAOW (x=(x+0xfff)&~0xfff) /////////////////////////// round up to next multiple of 0x1000
/*-----*/
int mesh::setnp_(int x,int k) {MIAOW; if(k?x==np_:x<=np_) return 1; Point*pp=point;
void*v=FR(point,Point,np_=x,"point"); if(!v) if(x) MessageBox(0,"points",nspac,OUCH);
int i; if(v) if(pp!=point) for(i=0;i<nq;i++) pts[i].p=point+(pts[i].p-pp); return !!v;}
/*-----*/
int mesh::setnt_(int x,int k) {MIAOW; if(k?x==nt_:x<=nt_) return 1; Texp*tt=t;
void*v=FR(t,Texp,nt_=x,"t"); if(!v) if(x) MessageBox(0,"texture map coords",nspac,OUCH);
int i; if(v) if(tt!=t) for(i=0;i<nq;i++) if(pts[i].t) pts[i].t=t+(pts[i].t-tt); return !!v;}
/*-----*/
int mesh::setnd_(int x,int k) {MIAOW; if(k?x==nd_:x<=nd_) return 1; xyz*dd=d;
void*v=FR(d,xyz,nd_=x,"d");  if(!v) if(x) MessageBox(0,"normals",nspac,OUCH);
int i; if(v) if(dd!=d) for(i=0;i<nq;i++) if(pts[i].d) pts[i].d=d+(pts[i].d-dd); return !!v;}
/*-----*/
int mesh::setnq_(int x,int k) {MIAOW; if(k?x==nq_:x<=nq_) return 1; fcinfo*qq=pts;
void*v=FR(pts,fcinfo,nq_=x,"q"); if(!v) if(x) MessageBox(0,"face-corners",nspac,OUCH);
int i; if(v) if(qq!=pts) for(i=0;i<nf;i++) if(fac[i].q) fac[i].q=pts+(fac[i].q-qq); return !!v;}
/*-----*/
int mesh::setnf_  (int x,int k) {MIAOW; int i=(k?x==nf_  :x<=nf_  )?1:FR(fac  ,Face ,nf_=x,"fac")!=0;
if(!i) if(x) MessageBox(0,"faces",nspac,OUCH); return i;}
/*-----*/
int mesh::setng_  (int x,int k) {MIAOW; int i=(k?x==ng_  :x<=ng_  )?1:FR(group,Group,ng_=x,"group")!=0;
if(!i) if(x) MessageBox(0,"groups",nspac,OUCH); return i;}
/*-----*/
int mesh::setntma_(int x,int k) {MIAOW; int i=(k?x==ntma_:x<=ntma_)?1:FR(tma  ,Tma,ntma_=x,"tma")!=0;
if(!i) if(x) MessageBox(0,"texture map areas",nspac,OUCH); return i;}
/*-----*/
int mesh::setnprt_(int x,int k) {MIAOW; int i=(k?x==nprt_:x<=nprt_)?1:FR(prt  ,Prt,nprt_=x,"prt")!=0;
if(!i) if(x) MessageBox(0,"parts",nspac,OUCH); return i;}
/*-----*/
int mesh::setnmat_(int x,int k) {MIAOW; int i=(k?x==nmat_:x<=nmat_)?1:FR(mat  ,Mat,nmat_=x,"mat")!=0;
if(!i) if(x) MessageBox(0,"materials",nspac,OUCH); return i;}
/*-----*/
long mesh::addpoint(xyz P,int r){if(!setnp_(np+1)) return 0; altered=1;
point[np].a=r?fromscr(P):P; point[np].r=r?P:toscr(P); return np++;}
/*-----*/
long mesh::findaddpoint(xyz p){reg long i,N=np; reg Point*Q=point;
for(i=0;i<N;i++) if(p==Q[i].a) return i; altered=1; return addpoint(p);}
/*----*/
void Face::setprops(mesh*OB){s=1; c=2; mat=OB->currentmat; g=OB->currentgroup; tma=0; prt=0;
if(mat<0) mat=0; if(g<0) g=0; memset(q,0,n*sizeof(fcinfo)); OB->altered=1;}
/*----*/
void deltrailsp(char*s){if(!s) return; int j=strlen(s),i=j; while(i<1?0:s[i-1]==' '?1:s[i-1]=='\t') i--; if(i<j) s[i]=0;}
/*----*/
Face*mesh::addface(int n){altered=1;
if(currentgroup<0?1:currentgroup>=ng) currentgroup=0; if(!ng) addgroup("default");
if(currentmat<0?1:currentmat>=nmat) currentmat=0;     if(!nmat) addmat(0x00808080,"default");
if(!ntma) addtma(); if(!nprt) addprt(); if(!setnq_(nq+n) ?1: !setnf_(nf+1)) return 0;;
Face&f=fac[nf++]; f.q=pts+nq; nq+=n; f.n=n; f.setprops(this); return &f;}
/*-----*/
Face*mesh::addface(fcinfo&A,fcinfo&B,fcinfo&C,Face*F){altered=1;
setnq_(nq+3); setnf_(nf+1); Face*G=fac+nf++; G->n=3; G->q=pts+nq; nq+=3; if(!G) return 0;
fcinfo*Q=G->q; Q[0]=A; Q[1]=B; Q[2]=C; *G<<*F; return G;}
/*-----*/
Face*mesh::addface(Point**PP,int n,int check) {short i,k; Face*f=addface(n);
// if(check) weed out successive identical corners
if(check) while(n<2?0:PP[0]==PP[n-1]) n--; fcinfo*QQ=f->q,*R;
for(k=i=0;i<n;i++) if(!check ?1: !i ?1: PP[i]!=PP[k-1]) {R=&QQ[k++]; if(PP) R->p=PP[i]; R->c=2; R->d=0; R->t=0;} 
f->n=k; return f;}
/*-----*/
Face*mesh::addface(fcinfo*PP,int n) {Face*f=addface(n); int i; if(PP) for(i=0;i<n;i++) f->q[i]=PP[i]; return f;}
/*-----*/
long mesh::addmat(COLORREF c,char*s){if(!setnmat_(nmat+1)) return 0; altered=1;
deltrailsp(s); Mat&q=mat[nmat]; q.df=c; q.rename(s?s:""); q.vis=1; return nmat++;}
/*-----*/
long mesh::findaddmat(COLORREF c,char*s){int i; altered=1; deltrailsp(s);
if(s) for(i=0;i<nmat;i++) if(!strcmp(s,mat[i].name)) return i; return addmat(c,s);}
/*-----*/
long mesh::addgroup(char*s){if(!setng_(ng+1)) return 0; altered=1; if(s) deltrailsp(s); setmem(group+ng,sizeof(Group),0);
group[ng].rename(s?s:""); group[ng].vis=1; return ng++;}
/*-----*/
long mesh::findaddgroup(char*s){long i; altered=1; deltrailsp(s);
for(i=0;i<ng;i++) if(!strcmp(s,group[i].name)) return i; return addgroup(s);}
/*-----*/
char*mesh::curgrpname(){int i=currentgroup; char*s=(i>=0?i<ng  :0)?group[i].name:"default";
return s?s:"_default";}
/*-----*/
char*mesh::curmatname(){int i=currentmat;   char*s=(i>=0?i<nmat:0)?mat  [i].name:"default";
return s?s:"_default";}
/*-----*/
long mesh::addtma(){if(!setntma_(ntma+1)) return 0;; Tma&q=tma[ntma]; q.vis=1; return ntma++;}
/*-----*/
long mesh::addprt(){if(!setnprt_(nprt+1)) return 0;; Prt&q=prt[nprt]; q.vis=1; return nprt++;}
/*-----*/
long mesh::addd(xyz v){setnd_(nd+1); d[nd]=v; altered=1; return nd++;}
/*-----*/
long mesh::findaddd(xyz p){long i; for(i=0;i<nd;i++) if(p==d[i]) return i; return addd(p);}
/*-----*/
long mesh::addt(xy v){if(!setnt_(nt+1)) return 0;; t[nt].a=v; t[nt].s=1; altered=1; return nt++;}
/*-----*/
long mesh::findaddt(xy v){long i; for(i=0;i<nt;i++) if(v==t[i].a) return i; return addt(v);}
/*----------*/
void mesh::colorsep(){long i,j; COLORREF c;
for(i=0;i<nmat;i++) {LOOP: c=mat[i].df;
    for(j=0;j<i;j++) if(c==mat[j].df) {mat[i].df=(c+1)&0x00ffffff; goto LOOP;}}}
/*-----*/
double arg(xyz W,int t){switch(t) {
case 0: default: return W.rr();
case 1: return W.x*W.x+W.y*W.y;
case 2: return W.z*W.z+W.y*W.y;}}
/*-----*/
double arg(xyz V,xyz W,int t){switch(t) {
case 0: default: return V.x*W.x+V.y*W.y+V.z*W.z;
case 1: return V.x*W.x+V.y*W.y;
case 2: return V.z*W.z+V.y*W.y;}}
/*-----*/
int mesh::inbox(Point&p){xyz W=p.r;
return (W.x<llm.x ?1: W.x>ulm.x) ?0: (W.y<llm.y ?1: W.y>ulm.y) ?0: !(W.z<llm.z ?1: W.z>ulm.z);}
/*-----*/
int mesh::inboxxz(Point&p){xyz W=p.r;
return (W.x<llm.x ?1: W.x>ulm.x) ?0: !(W.z<llm.z ?1: W.z>ulm.z);}
/*-----*/
long mesh::nearestpointto(xyz jerry,int t){char k=0; xyz W; double v,w=1e50;
Point*p,*q=0; selcorn();
AGAIN: forpoint(p) {if(!k) if(!inboxxz(*p)) continue; v=arg(jerry-p->r,t); if(v<w) {w=v; q=p;};}
if(!k) if(!q) {k=1; goto AGAIN;}; return q?q-point:-1;}
/*-----*/
long mesh::nearesttexpto(xy jerry){xy W,Z; Texp*T,*q=0; double v,w=1e50;
seltex(); fortex(T) {Z=jerry-T->a; v=Z.x*Z.x+Z.y*Z.y; if(v<w) {w=v; q=T;}}
return !q?-1:w==1e50?-1:q-t;}
/*-----*/
long mesh::nearesttexpto(xy jerry,Face*F){xy W,Z; Texp*T,*q=0; double v,w=1e50; fcinfo*I,*V,*VL;
if(!F ?1: (I=F->q,!I)) return nearesttexpto(jerry);
forvert() if(T=V->t,T) {
	 W=T?T->a:xy(0,0); Z=jerry-W; v=Z.x*Z.x+Z.y*Z.y; if(v<w) {w=v; q=T;}}
return !q?-1:w==1e50?-1:q-t;}
/*-----*/
void mesh::nearestedgeto(xyz jerry,int t){
long k=0; xyz W; double v,w=1e50; fcinfo*I,*V,*VL; Face*F,*FL;
forallface() funnyface(F-fac);
AGAIN: nFW=0;
forface() forvert() {W=F->edgemidr(V-I);
	 if(!k) if(W.x<llm.x ?1: W.x>ulm.x ?1: W.z<llm.z ?1: W.z>ulm.z) continue;
	 v=arg(jerry-W,t); if(v<w) {w=v; nFW=1; FW[0]=Facen(F-fac,V-I);};}
if(!nFW) if(!k) {k=1; t|=4; goto AGAIN;}}
/*-----*/
int mesh::splitcurrentedge(long N,int findt,int tri){double d1,d2,sd; fcinfo*I,*PP,*Q,*R,*S; Face*F,G;
Facen W; if(!nFW ?1: (F=fac+FW[0].f,!F->q)) return 0; int i,j,k,l,n=F[0].n;
if(F->n<3) {FW[1]=FW[0]; nFW=2;} else findsameedges();
if(point+N==F->q[n].p ?1: point+N==F->q[(n+1)%F->n].p) {nFW=0; return 0;}
for(j=0,i=1;i<nFW;i++) j+=fac[FW[i].f].n+1; if(!setnq_(nq+j+(nFW*(nFW+1))/2)) return 0;
OB->setnt_(nt+nFW+1); PP=pts+nq;
for(i=1;i<nFW;i++) if(FW[i].f==FW[0].f) if(FW[i].n==FW[0].n) break;
if(i<nFW-1) {W=FW[i]; FW[i]=FW[nFW-1]; FW[nFW-1]=W;}
for(i=1;i<nFW;i++) {F=&fac[FW[i].f]; n=F->n; j=FW[i].n; if(j<0?1:j>=n) continue;
	 G=*F; I=F->q; if(!I) continue; G.q=PP; G.n=n+1;
	 for(l=1,k=j+1;k<n;k++) PP[l++]=I[k]; for(k=0;k<=j;k++) PP[l++]=I[k]; PP[0]=I[j];
	 Q=&PP[n]; R=&PP[0]; S=&PP[1]; R->p=&point[N]; PP+=n+1; nq+=n+1;
	 d1=(R->p->a-Q->p->a).r(); d2=(R->p->a-S->p->a).r(); sd=d1+d2;
	 if(!sd) {d1=d2=1; sd=2;} R->t=0; R->d=0;
	 if(findt) if(Q->t) if(S->t) {k=findaddt(Q->t->a*(d2/sd)+S->t->a*(d1/sd)); R->t=t+k;}
//                  if(Q->d) if(S->d) {nn=*Q->d*d2+*S->t*d1; sd=nn.r();
//                      R->d=d+addd(sd?nn*(1/sd):*Q->d);}
		  *F=G;}
if(tri) for(i=1;i<nFW;i++) triangularize(FW[i].f);
//for(i=1;i<nFW;i++) fac[FW[i].f].q=0;
//char s[64]; sprintf(s,"nq=%d, nq_=%d",nq,nq_); MessageBox(0,s,s,OUCH);
altered=1; nFW=0; return 1;}
/*-----*/
long mesh::nearestfaceto(xyz jerry,int t){
long i=t&4,j; xyz W; double v,w=1e50; fcinfo*I; Face*F,*FL;
j=-1; forallface() if(i?1:F->s) {
	 W=F->midr(); if(W.x<llm.x ?1: W.x>ulm.x ?1: W.z<llm.z ?1: W.z>ulm.z) continue;
	 v=arg(jerry-W,(t&3)); if(v<w) {w=v; j=F-fac;};}
if(j<0) if(t&4) {j=-1; forallface() if(i?1:F->s) {
		  W=F->midr(); v=arg(jerry-W,(t&3)); if(v<w) {w=v; j=F-fac;};}}
return j<0?-1:j>=nf?-1:j;}
/*-----*/
long mesh::nearestfacetotex(xyz jerry,int selonly){
long j=-1; xyz W; double v,w=1e50; fcinfo*I; Face*F,*FL;
if(selonly) forface() if(OB->gm(F)) {W=xyz(F->midrtex()); v=arg(jerry-W,1); if(v<w) {w=v; j=F-fac;}}
if(j<0)  forallface() if(OB->gm(F)) {W=xyz(F->midrtex()); v=arg(jerry-W,1); if(v<w) {w=v; j=F-fac;}}
return j;}
/*-----*/
void mesh::split(Face&F,xyz P){split(F,point+addpoint(P,1));}
/*-----*/
double dfl(xy p,xy A,xy B){return B.x*A.y+p.x*B.y-A.x*B.y-p.x*A.y-B.x*p.y+A.x*p.y;} /* distance from line */
/*-----*/
void mesh::split(Face&F,Point*Q,xy S){
int i,j,k,l,f=&F-fac,n=F.n; Texp*T=t+addt(xy(.001,.001)); xy U;
if(!setnq_(nq+n*3) ?1: !setnf_(nf+n) ?1: !Q) return; U.x=U.y=0;
Face*H=fac+nf; Face*G=&fac[f]; fcinfo*I=G->q,*J=pts+nq; if(!I) return; k=nf; double w=0,*dp=FM(double,n);
for(i=0;i<n;i++) {dp[i]=(I[i].p->a-Q->a).r(); if(!dp[i]) dp[i]=1e-12;}
if(!S.x) if(!S.y) {for(i=0;i<n;i++) if(I[i].t) {S=S+(I[i].t->a*(1./dp[i])); w+=1./dp[i];} if(w) S=S*(1./w);}
for(j=i=0;i<n;i++) {*H=*G; H->n=3; (*H++).q=J; if(I[i].t) {j++; U=U+I[i].t->a;}
	 *J++=I[i]; *J++=I[(i+1)%n]; J->d=0; J->t=T; J->c=J->e=0; (*J++).p=Q;}
nq+=n*3; nf+=n; G->q=0; /* mark the old face as dead */ if(j) T->a=S/*U/j*/; altered=1;
do for(j=nf,i=k;i<nf;i++) for(l=0;l<fac[i].n;l++) {
	 I=fac[i].q; if(!I) break; splitface(I[l].p-point,I[(l+1)%fac[i].n].p-point);}
while(nf>j); FF(dp);}
/*-----*/
void mesh::splitt(Face&F,xy P){if(!&F) return;
//char L[256]; sprintf(L,"splitt at {%g,%g}",P.x,P.y); MessageBox(0,L,"",OUCH);
int i,n=F.n; xy U(0,0); fcinfo*I=F.q; if(!I) return;
double w=0,*dt=FM(double,n); xyz S(0,0,0); xy T;
for(i=0;i<n;i++) {T.x=T.y=0; if(I[i].t) T=I[i].t->a; T=T-P; dt[i]=T.r(); if(!dt[i]) dt[i]=1e-12;}
//char L[512]; L[0]=0;
//for(i=0;i<n;i++) sprintf(L+strlen(L),"%g ",dt[i]); MessageBox(0,L,"dt",OUCH);
for(i=0;i<n;i++) {S=S+(I[i].p->a*(1./dt[i])); w+=1./dt[i];} S=S*(1./w);
//sprintf(L,"%g %g %g",S.x,S.y,S.z); MessageBox(0,L,"S",OUCH);
split(F,point+addpoint(S,0),P); FF(dt);}
/*-----*/
void mesh::findsameedges(){if(!nFW) return;
Face*FF=&fac[FW[0].f],*F,*FL; fcinfo*I=FF->q,*V,*VL; if(!I) return;
long k=FW[0].n,n=FF->n; /* current edge is k'th edge of face F, which has n edges */
Point*u=I[k].p,*v=I[(k+1)%n].p; /* ends of current edge */
forallface() funnyface(F-fac,1);
nFW=1; forallface() forvert() {
	 Point*U=V->p,*W=(V+1==VL?I:V+1)->p; /* ends of edge V */
	 if(nFW<maxFW) if(u==U?v==W:0) FW[nFW++]=Facen(F-fac,V-I,0); /* syn match */
				 else if(u==W?v==U:0) FW[nFW++]=Facen(F-fac,V-I,1);} /* anti match */}
/*-----*/
double mesh::xyarea(Face*F,xyz*p){int i,j=F->n; double a=0; xyz*u=FM(xyz,j+1);
for(i=0;i<j;i++) u[i]=p[F->q[i].p-point]; u[j]=u[0];
for(i=0;i<j;i++) a+=(u[i+1].x-u[i].x)*(u[i+1].y+u[i].y); FF(u); return -a/2;}
/*-----*/
double mesh::zyarea(Face*F,xyz*p){int i,j=F->n; double a=0; xyz*u=FM(xyz,j+1);
for(i=0;i<j;i++) u[i]=p[F->q[i].p-point]; u[j]=u[0];
for(i=0;i<j;i++) a+=(u[i+1].z-u[i].z)*(u[i+1].y+u[i].y); FF(u); return -a/2;}
/*-----*/
double mesh::zxarea(Face*F,xyz*p){int i,j=F->n; double a=0; xyz*u=FM(xyz,j+1);
for(i=0;i<j;i++) u[i]=p[F->q[i].p-point]; u[j]=u[0];
for(i=0;i<j;i++) a+=(u[i+1].z-u[i].z)*(u[i+1].x+u[i].x); FF(u); return -a/2;}
/*-----*/
double Face::xyarea(){int i,j=n; double a=0; xyz*u=FM(xyz,j+1);
for(i=0;i<j;i++) u[i]=q[i].p->r; u[j]=u[0];
for(i=0;i<j;i++) a+=(u[i+1].x-u[i].x)*(u[i+1].y+u[i].y); FF(u); return -a/2;}
/*-----*/
double Face::zyarea(){int i,j=n; double a=0; xyz*u=FM(xyz,j+1);
for(i=0;i<j;i++) u[i]=q[i].p->r; u[j]=u[0];
for(i=0;i<j;i++) a+=(u[i+1].z-u[i].z)*(u[i+1].y+u[i].y); FF(u); return -a/2;}
/*-----*/
double Face::zxarea(){int i,j=n; double a=0; xyz*u=FM(xyz,j+1);
for(i=0;i<j;i++) u[i]=q[i].p->r; u[j]=u[0];
for(i=0;i<j;i++) a+=(u[i+1].z-u[i].z)*(u[i+1].x+u[i].x); FF(u); return -a/2;}
/*-----*/
double Face::uvarea(){int i,j=n; double a=0; xy*u=FM(xy,j+1);
for(i=0;i<j;i++) u[i]=q[i].t?q[i].t->a:xy(0,0); u[j]=u[0];
for(i=0;i<j;i++) a+=(u[i+1].x-u[i].x)*(u[i+1].y+u[i].y); FF(u); return -a/2;}
/*-----*/
void Face::turn(){int i,j=n/2,k=n-1; fcinfo Z,*I=q; if(I) for(i=0;i<j;i++) {Z=I[i]; I[i]=I[k-i]; I[k-i]=Z;}}
/*-----*/// no check for re-entrant yet
double Face::angle(int i){return xyangle(q[(i+n-1)%n].p->a,q[i%n].p->a,q[(i+1)%n].p->a);}
/*-----*/
int Face::operator==(Face&F){int i,j; if(n!=F.n?1:!q?1:!F.q) return 0;
for(i=0;i<n;i++) {for(j=0;j<n;j++) if(q[j].p!=F.q[(j+i)%n].p) goto F1; return 1; F1:;}
for(i=0;i<n;i++) {for(j=0;j<n;j++) if(q[j].p!=F.q[(n-j+i)%n].p) goto F2; return 1; F2:;} return 0;}
/*-----*/
//class edge2{public: long k; short n;};
//class edgel2{public: long p,e; short n;};
//class edgel{public: edgel2*op; short n;};
/*-----*/// corner i is feinfo[i].n'th in face feinfo[i].k
void mesh::findedges(){Face*F,*FL; fcinfo*I,*V,*VL; long e,i,j,k,p1,p2;
other=FM(long,nq); nop=nq; syn=FM(char,nq); for(i=0;i<nq;i++) syn[i]=-1;
ptop=FM(edgel,np); for(i=0;i<np;i++) {ptop[i].op=0; ptop[i].n=0;}
feinfo=FM(edge2,nq); forallface() forvert() {feinfo[V-pts].k=F-fac; feinfo[V-pts].n=V-I;}
for(i=0;i<nq;i++) {other[i]=-1; pts[i].c=0;}
forallface() forvert() {p1=V->p-point; p2=(V+1==VL?I:V+1)->p-point; if(p1>p2) {i=p1;p1=p2;p2=i;}
	 e=V-pts; edgel&P=ptop[p1]; for(i=0;i<P.n;i++) if(p2==P.op[i].p) goto FOUND;
	 FR(P.op,edgel2,P.n+1,"edgel2"); P.op[P.n].p=p2; P.op[P.n].e=e; P.op[i=P.n++].n=0;
	 FOUND: j=++P.op[i].n;
	 if(j==2) {other[e]=k=P.op[i].e; other[k]=e; syn[e]=syn[k]=V->p==pts[k].p?1:0;}}
forallface() forvert() {p1=V->p-point; p2=(V+1==VL?I:V+1)->p-point; if(p1>p2) {i=p1;p1=p2;p2=i;}
	 edgel&P=ptop[p1]; for(i=0;i<P.n-1;i++) if(p2==P.op[i].p) break; V->c=(byte)P.op[i].n;}}
/*-----*/
void mesh::deledgeinfo(){int i;
for(i=0;i<np;i++) FF(ptop[i].op); FF(ptop); FF(syn); FF(feinfo); FF(other); nop=0;}
/*-----*/
void mesh::checkedges(int turnfaces,int ngc,int nodelinfo){
if(turnfaces) if(selface<0) return;
Face*F,*FL; fcinfo*I,*V,*VL; char*X=0,*wayup=0,C[128]; long i,j,k,l,m,o,b;
if(!ngc) collectgarbage(); findedges();
if(!(turnfaces&1)) {forallface() forvert() if(V->c==2) if(syn[V-pts]) V->c=255; goto END;}
X=FM(char,nf); wayup=FM(char,nf); for(i=0;i<nf;i++) X[i]=wayup[i]=-1;
X[selface]=0; wayup[selface]=fac[selface].xyarea()>0?0:1; k=0; b=1;
LOOP: m=0; k++;
forallface() if(!X[F-fac]) {X[F-fac]=1;
	 forvert() if(V->c==2) if(l=other[j=V-pts],l>=0) {o=feinfo[l].k;
		  if(X[o]<0) {wayup[o]=syn[j]?1-wayup[F-fac]:wayup[F-fac]; X[o]=0; m++; b++;}
		  else if(syn[j]) V->c=255; /* Mobius */}}
for(i=0;i<nf;i++) if(X[i]==3) X[i]=0; if(m) goto LOOP;
END: if(!nodelinfo) deledgeinfo();
if(turnfaces) {
	 j=0; forallface() if(wayup[F-fac]==0) {j++; F->turn();} checkedges(0);
    sprintf(C,"%d iterations, %d reversed faces found, %d faces checked",k,j,b);
	 MessageBox(0,C,"checkedges",MB_OK);}
FF(X); FF(wayup);}
/*-----*//* unweld surfaces stuck together at one point */
void mesh::unstick(){short*natp,*P; int i,j,k,m,n,o=np; char C[32]; Face*F,*FL; fcinfo*I,*V,*VL;
typedef struct{Face*F;short V;char i;} poly; poly*p=FM(poly,nq),*q/*,Q*/; Face*G; int u,v;
char*ok=FM(char,nq); for(i=0;i<nq;i++) ok[i]=0;
LOOP3: P=FM(short,np); natp=FM(short,np); for(i=0;i<np;i++) natp[i]=0;
forface() forvert() natp[V->p-point]++;
for(j=i=0;i<np;i++) {P[i]=j; j+=natp[i];}
for(i=0;i<nq;i++) {p[i].F=0; p[i].i=0;}
forface() forvert() {i=V->p-point; q=p+P[i]+(p[i].i++); q->F=F; q->V=V-I;}
for(i=0;i<nq;i++) p[i].i=0;
for(i=0;i<np;i++) if(!ok[i]) if(n=natp[i],q=p+P[i],q->F) {q[0].i=1; LOOP2:
     for(m=j=0;j<n;j++) if(q[j].i) {F=q[j].F; u=q[j].V;
		  for(k=0;k<n;k++) if(!q[k].i) {G=q[k].F; v=q[k].V;
            int u1=(u+1)%F->n,u2=(u+F->n-1)%F->n,v1=(v+1)%G->n,v2=(v+G->n-1)%G->n;
				if(F->q[u1].p==G->q[v1].p ?1: F->q[u1].p==G->q[v2].p ?1:
                F->q[u2].p==G->q[v1].p ?1: F->q[u2].p==G->q[v2].p) {q[k].i=1; m++;}}}
    if(m) goto LOOP2;
    for(m=k=0;k<n;k++) if(!q[k].i) m++; if(!m) ok[i]=1;
    if(!m) continue; /* good vertex */
	 sprintf(C,"splitting vertex %d",i); SetTitle(Wn,C);
//    for(l=1,j=n-1;l;j--) for(l=0,k=0;k<j;k++) if(!q[k].i) if(q[k+1].i) {
//        l=1; Q=q[k+1]; q[k+1]=q[k]; q[k]=Q;}
	 for(j=0;j<n;j++) if(!q[j].i) q[j].F->q[q[j].V].p=point+np; ok[i]=1; ok[np++]=0;
    if(!setnp_(np,1)) goto WHOA; point[np-1]=point[i]; FF(natp); FF(P); goto LOOP3;}
sprintf(C,"%d new vertexes created by unwelding",np-o);
MessageBox(0,C,"unglue stuck surfaces",IDOK); //   fclose(Z);
WHOA: FF(ok); FF(natp); FF(P); FF(p);}
/*-----*/
//#define DEB "d:\\b\\makeobj\\_.cpp"
int mesh::funnyface(int f,int _) {Face*F=&fac[f],*G; fcinfo*I=F->q,*J; if(!I) return 0;
int g,h,i,j,k=0,n=F->n;
SAME: if(!I) return k; if(n<3) {F->q=0; return 1;}
if(_) {for(i=2;i<n;i++) /* look for the same vertex at 2 adjacent-but-one corners */
	 if(I[i-2].p==I[i].p) {for(j=i+1;j<n;j++) I[j-2]=I[j]; n-=2; k++; goto SAME;}
	 if(I[n-1].p==I[1].p) {for(j=1;j<n;j++) I[j-1]=I[j]; n-=2; k++; goto SAME;}
	 if(I[n-2].p==I[0].p) {n-=2; k++; goto SAME;}}
for(i=1;i<n;i++) /* look for the same vertex at 2 adjacent corners */
  if(I[i-1].p==I[i].p) {for(j=i;j<n;j++) I[j-1]=I[j]; n-=1; k++; goto SAME;}
if(I[n-1].p==I[0].p) {n-=1; k++; goto SAME;} F->n=n;
// look for other cases of the same vertex twice
if(_) for(i=1;i<n;i++) for(j=0;j<i;j++) if(I[i].p==I[j].p) goto FIGURE_OF_8; return k;
FIGURE_OF_8: setnq_(nq+n); setnf_(nf+1); F=&fac[f]; I=F->q; F->q=0;
G=fac+(g=nf); nf++; *G=*F;
J=G->q=pts+nq; nq+=n; for(h=j;h<i;h++) *J++=I[h]; G->n=J-G->q; // split the face
F->q=J; for(h=i;h<n;h++) *J++=I[h]; for(h=0;h<j;h++) *J++=I[h]; F->n=J-F->q;
altered=1; k+=funnyface(f,_); return k+funnyface(g,_);}
/*-----*//* assumes that the face is anticlockwise out */
void Face::flat(xy*C){int i; xyz P(0,0,0),*N=FM(xyz,2*n),*a=N+n; double c,s,r,w;
for(i=0;i<n;i++) {a[i]=q[i].p->a; N[i]=normal(i); P+=N[i];} w=P.r(); if(w) P/=w;
r=sqrt(P.x*P.x+P.y*P.y); if(r) {c=P.x/r; s=P.y/r;} else {c=1; s=0;}
for(i=0;i<n;i++) {w=a[i].x*c+a[i].y*s; a[i].y=-a[i].x*s+a[i].y*c; a[i].x=w;}w=P.x*c+P.y*s; P.y=-P.x*s+P.y*c; P.x=w;
r=sqrt(P.x*P.x+P.z*P.z); if(r) {s=P.x/r; c=P.z/r;} else {s=0; c=1;}
for(i=0;i<n;i++) {w=a[i].x*c-a[i].z*s; a[i].z=a[i].x*s+a[i].z*c; a[i].x=w;}
for(i=0;i<n;i++) {C[i].x=a[i].x; C[i].y=a[i].y;} FF(N);}
/*-----*//* normal at vn'th corner of face; the face is assumed to be anticlockwise out */
xyz Face::normal(int vn){fcinfo*U=q+(vn?vn-1:n-1),*V=q+vn,*W=q+(vn+1)%n; double r;
xyz c=V->p->a, a=W->p->a-c, b=U->p->a-c, N(a.y*b.z-a.z*b.y, a.z*b.x-a.x*b.z, a.x*b.y-a.y*b.x);
r=N.rr(); return r?N/sqrt(r):N;}
/*-----*/
static int ndeledges,F1q,F2q;
/*-----*/
int mesh::deledge(int p){findsameedges(); selface=-1; long g1,g2,m1,m2,ne=nFW-1,i,j,k,l,m,n,rg,rm;
Face*F1,*F2; fcinfo*I,*J; fcinfo*Q; char a1,a2; nFW=0; altered=1; if(p) if(ne!=2) return 0;
switch(ne) {
default: DEF: {char L[64]; sprintf(L,"%d faces meet on this edge",ne);
	 MessageBox(0,L,"deledge",OUCH);} KEYS[VK_SHIFT]=0; return 0;
case 1: if(k=MessageBox(0,"do you want to delete the face?","this is a loose edge",
			 MB_YESNO)!=IDNO,k) fac[FW[1].f].q=0; nFW=0; return k; /* delete the face */
case 2: { /* join 2 faces */ if(KEYS[VK_SHIFT]) goto DEF;
	 static char*ync="%s (yes) or %s (no) or don't remove the edge (cancel)";
	 if(!setnf_(nf+1)) goto DEF; m=fac[FW[1].f].n; n=fac[FW[2].f].n;
	 if(!setnq_(nq+m+n+2)) goto DEF; F1=&fac[FW[1].f]; F2=&fac[FW[2].f]; I=F1->q; J=F2->q;
	 a1=char(FW[1].anti); a2=char(FW[2].anti); /**/
	 if(!I?1:!J) return 0;
	 if(F1==F2) {k=0; goto SAME;}
	 k=FW[1].n; l=FW[2].n; m1=F1->mat; m2=F2->mat; g1=F1->g; g2=F2->g; char LG[128],LM[128]; rg=rm=IDYES;
	 if(KEYS[VK_END]) if(g1!=g2 ?1: m1!=m2 ?1: F1->tma!=F2->tma) return 0;
	 if(g1!=g2) {sprintf(LG,ync,group[g1].name,group[g2].name);
		  rg=MessageBox(0,LG,"which of these groups is the new face to be in?",3); if(rg==IDCANCEL) return 0;}
	 if(m1!=m2) {sprintf(LM,ync,mat[m1].name,mat[m2].name);
		  rm=MessageBox(0,LM,"which of these materials is the new face to be in?",3); if(rm==IDCANCEL) return 0;}
	 if(F1->tma!=F2->tma)
		  if(MessageBox(0,"shall I remove it?","this edge is between different texture map areas",MB_YESNO)==IDNO) return 0;
	 Q=FM(fcinfo,m+n); j=0; for(i=k+1;i<=k+m;i++) Q[j++]=I[i%m]; // b=n+l+2; e=n+l-1;
	 if(a1==a2) for(i=n+l-1;i>=l+2;i--) Q[j++]=J[i%n];
	 else       for(i=l+2;i<=n+l-1;i++) Q[j++]=J[i%n];
	 Face*newf=OB->addface(Q,j); F1q=F1->q-pts; F2q=F2->q-pts; F1->q=F2->q=0; FF(Q); ndeledges++;
	 if(rg==IDYES) *newf<<*F1; else *newf<<*F2; newf->mat=rm==IDYES?F1->mat:F2->mat;} k=1;}
SAME: funnyface(F1-fac); return k;}
/*-----*/
int mesh::delpoint(){if(selpoint<0) return 0; long i,j,m,p=0,P=selpoint; altered=1;
fcinfo*I,*V,*VL; Face*F,*FL; ndeledges=0; altered=1;
if(KEYS[VK_CONTROL]) {
	 forallface() {
		  forvert() if(V->p==point+P) if(F->n>0) {for(j=V-I+1;j<F->n;j++) I[j-1]=I[j]; F->n--; break;}}
	 return 1;}
LOOP: forallface() funnyface(F-fac);
forallface() {i=F-fac; m=F->n;
	 forvert() if(V->p==point+P) {j=V-I;
		  FW[0]=Facen(i,j);         nFW=1; p++; if(deledge(1)) goto LOOP;
		  FW[0]=Facen(i,(j-1+m)%m); nFW=1; p++; if(deledge(1)) goto LOOP;}}
nFW=0; return !!p;}
/*-----*/
int mesh::splitface(Face*F,int j,int k) {fcinfo*q=F->q,*Q,*R; int i,m,n=F->n;
if(j>k) {i=j; j=k; k=i;} if(!q?1:j+1==k?1:k+1==j+n?1:j==k?1:j<0?1:k>=n) return 0;
if(!setnq_(nq+n+2)) {MessageBox(0,"nq out of room","splitface",OUCH); return 0;}
i=F-fac;
if(!setnf_(nf+1)) {MessageBox(0,"nf out of room","splitface",OUCH); return 0;}
F=fac+i; q=F->q; Q=pts+nq; nq+=n+2; Face*G=fac+nf; nf++;
*G=*F; for(m=0,i=j;i<=k;i++) Q[m++]=q[i]; G->q=Q; G->n=m; altered=1;
R=Q+m; for(m=i=0;i<=j;i++) R[m++]=q[i]; for(i=k;i<n;i++) R[m++]=q[i]; F->q=R; F->n=m; return 1;}
/*-----*/
#if 0
double eqnsolve3(double bx,double by,double bz,  double cx,double cy,double cz,
					  double dx,double dy,double dz,  double  b,double  c,double  d,
					  double &B,double &C,double &D){
double det=bx*cy*dz+dx*by*cz+cx*dy*bz-dx*cy*bz-cx*by*dz-bx*dy*cz; if(det*det<1e-30) return det;
B=        (b *cy*dz+d *by*cz+c *dy*bz-d *cy*bz-c *by*dz-b *dy*cz)/det;
C=        (bx*c *dz+dx*b *cz+cx*d *bz-dx*c *bz-cx*b *dz-bx*d *cz)/det;
D=        (bx*cy*d +dx*by*c +cx*dy*b -dx*cy*b -cx*by*d -bx*dy*c )/det; return det;}
#endif
/*-----*/
long mesh::edgesel(xyz jerry,int t){long i,j,n; double v,w;
if(selface<0) return -1; Face*F=&fac[selface]; fcinfo*I=F->q; if(!I) return -1;
for(w=1e20,n=F->n,j=i=0;i<n;i++) {v=arg(F->edgemidr(i)-jerry,t); if(v<w) {j=i; w=v;}}
return j>=n?-1:j;}
/*-----*/
void mesh::sel1point(Point*p){int i; for(i=0;i<np;i++) point[i].h=0; if(p) p->h=1;}
/*-----*/
long mesh::pointsel(xyz jerry,int t){long i,j,n; double v,w;
if(selface<0) return -1; Face*F=&fac[selface]; fcinfo*I=F->q; if(!I) return -1;
for(w=1e20,n=F->n,j=i=0;i<n;i++) {v=arg(I[i].p->r-jerry,t); if(v<w) {j=i; w=v;}}
return j>=n?-1:j;}
/*-----*/
void hmemset(void*p,char c,long n){register char*q=(char*)p,d=c,*r=q+n; while(q<r) *q++=d;}
/*-----*/
void mesh::collectgarbage(){TempTitle(Wn,"collecting garbage");
fcinfo*I,*V,*VL,*W,*Q,*R; Face*F,*FL,*G; long i,j=0,k=0; nFW=0; selpoint=seltexp=-1;
char*s=check(),S[256],sffound=0; if(s) {MessageBox(0,s,"fault in mesh",OUCH); return;}
for(i=0;i<nf;i++) funnyface(i,1);
{char*s=check(); if(s) {MessageBox(0,s,"fault in mesh after face tidying",OUCH); return;}}
if(j+k){sprintf(S,"%d identical adjacent face-corners welded; %d faces then had < 3 corners",j,k);
/*  MessageBox(0,S,"collecting garbage",MB_OK);*/}
for(k=0,F=fac,FL=fac+nf;F<FL;F++) if(F->q) k+=F->n; Q=FM(fcinfo,k);
for(F=G=fac;F<FL;F++) if(F->q) {if(F!=G) *G=*F; if(F-fac==selface) {selface=G-fac; sffound=1;} G++;}
if(!setnf_(nf=G-fac)) return; FL=fac+nf;
for(R=Q,F=fac;F<FL;F++) for(W=F->q,F->q=R,j=0;j<F->n;j++) *R++=*W++; nq_=nq=k; FF(pts); pts=Q;
long*nfatp=FM(long,np+16); for(i=0;i<np;i++) nfatp[i]=0; /* find which vertex info is live */
long*nfatt=FM(long,nt+16); for(i=0;i<nt;i++) nfatt[i]=0;
long*nfatd=FM(long,nd+16); for(i=0;i<nd;i++) nfatd[i]=0;
forallface() forvert(){nfatp[V->p-point]++; if(V->t) nfatt[V->t-t]++; if(V->d) nfatd[V->d-d]++;}
/* pack arrays & list new addresses of their elements */
for(j=i=0;i<np;i++) if(nfatp[i]) {if(i!=j) point[j]=point[i]; nfatp[i]=j++;} setnp_(np=j,1);
for(j=i=0;i<nt;i++) if(nfatt[i]) {if(i!=j)     t[j]=    t[i]; nfatt[i]=j++;} setnt_(nt=j,1);
for(j=i=0;i<nd;i++) if(nfatd[i]) {if(i!=j)     d[j]=    d[i]; nfatd[i]=j++;} setnd_(nd=j,1);
forallface() forvert() { /* reset addresses in fcinfo's to match */
	 V->p=point+nfatp[V->p-point]; if(V->t) V->t=t+nfatt[V->t-t]; if(V->d) V->d=d+nfatd[V->d-d];}
FF(nfatp); FF(nfatt); FF(nfatd); if(!sffound) selface=-1;
/* remove empty groups & materials */
{long*Nf=FM(long,ng),*ngn=FM(long,ng); for(i=0;i<ng;i++) Nf[i]=0; forallface() Nf[F->g]++;
for(i=j=0;i<ng;i++) if(Nf[i]) ngn[i]=j++; forallface() F->g=(short)ngn[F->g];
for(i=0;i<ng;i++) if(Nf[i]) if(k=ngn[i],i!=k) group[k]=group[i]; ng=j; FF(Nf); FF(ngn);
if(!ng) addgroup("default"); OB->currentgroup=min(OB->currentgroup,OB->ng-1);
Nf=FM(long,nmat); ngn=FM(long,nmat); for(i=0;i<nmat;i++) Nf[i]=0; forallface() Nf[F->mat]++;
for(i=j=0;i<nmat;i++) if(Nf[i]) ngn[i]=j++; forallface() F->mat=(short)ngn[F->mat];
for(i=0;i<nmat;i++) if(Nf[i]) if(k=ngn[i],i!=k) mat[k]=mat[i]; nmat=j; FF(Nf); FF(ngn);}
if(!nmat) addmat(0xffffff,"default"); OB->currentmat=min(OB->currentmat,OB->nmat-1);}
/*-----*/
void mesh::collectgarbaget(){fcinfo*I,*V,*VL; Face*F,*FL; long i,j,Nt; if(!nt) return;
char*s=check(); if(s) {MessageBox(0,s,"fault in mesh",OUCH); return;}
long*nfatt=FM(long,nt); for(i=0;i<nt;i++) nfatt[i]=0;
forallface() forvert() if(V->t) if(i=V->t-t,i<0?1:i>=nt) V->t=0; else nfatt[i]++;
for(Nt=i=0;i<nt;i++) if(nfatt[i]) Nt++; Texp*T=FM(Texp,Nt),*ot=t;
for( j=i=0;i<nt;i++) if(nfatt[i]) {T[j]=t[i]; nfatt[i]=j++;} nt_=nt=Nt; t=T;
forallface() forvert() if(V->t) V->t=t+nfatt[V->t-ot]; FF(ot); FF(nfatt);}
/*-----*/
void mesh::setcifsel(){int i; fcinfo*I,*V,*VL; Face*F,*FL;
for(i=0;i<np;i++) point[i].c=0; forface() forvert() V->p->c=1;}
/*-----*///weld all close points (if they are on loose edges if all==0)
void mesh::weldall(int all){long i,ii,j,k,n,II,J; xyz p; char tit[1024],nt[32];
Face*F,*FL; fcinfo*I,*U,*V,*VL; collectgarbage(); checkedges(); altered=1;
for(i=0;i<np;i++) point[i].c=0; for(i=0;i<nq;i++) pts[i].e=0;
forface() forvert() if(all?1:V->c==1) {U=V+1==VL?I:V+1; V->p->c=U->p->c=V->e=U->e=1;}
for(i=n=0;i<np;i++) if(point[i].c==1) n++; long*d=FM(long,n); char*c=FM(char,np);
for(j=i=0;i<np;i++) if(k=c[i]=(point[i].c==1),k) d[j++]=i; GetTitle(mwn,tit,256);
double Max=ask(mwn,"max distance?","1e-5"); Max=Max*Max;
for(ii=0,II=n-1;II>=0?!KEYS[VK_ESCAPE]:0;II--) if(c[i=d[II]]) {
    if(!(ii++&0xff)) {sprintf(nt,"%6d",i); SetTitle(mwn,nt);} p=point[i].a;
    for(J=0;J<II;J++) if((p-point[j=d[J]].a).rr()<=Max) {c[j]=0;
        for(k=0;k<nq;k++) if(U=&pts[k],U->p==point+j) U->p=point+i;}}
SetTitle(mwn,tit); FF(c); FF(d); }
/*-----*///bring together all close points (if they are on loose edges if all==0)
void mesh::weldall4(int all){long i,ii,j,k,n,II,J; xyz p; char tit[1024],nt[32];
Face*F,*FL; fcinfo*I,*U,*V,*VL; collectgarbage(); checkedges(); altered=1;
for(i=0;i<np;i++) point[i].c=0; for(i=0;i<nq;i++) pts[i].e=0;
forface() forvert() if(all?1:V->c==1) {U=V+1==VL?I:V+1; V->p->c=U->p->c=V->e=U->e=1;}
for(i=n=0;i<np;i++) if(point[i].c==1) n++; long*d=FM(long,n); char*c=FM(char,np);
for(j=i=0;i<np;i++) if(k=c[i]=(point[i].c==1),k) d[j++]=i; GetTitle(mwn,tit,256);
double Max=ask(mwn,"max distance?","1e-5"); Max=Max*Max;
for(ii=0,II=n-1;II>=0?!KEYS[VK_ESCAPE]:0;II--) if(c[i=d[II]]) {
	 if(!(ii++&0xff)) {sprintf(nt,"%6d",i); SetTitle(mwn,nt);} p=point[i].a;
	 for(J=0;J<II;J++) if((p-point[j=d[J]].a).rr()<=Max) {c[j]=0; point[j].a=point[i].a; point[j].r=point[i].r;}}
SetTitle(mwn,tit); FF(c); FF(d); }
/*-----*/// weld all close points that are at the ends of the sdame face-edge
void mesh::weldall2(){Point*P,*Q; long i,j,k,l; xyz p,w,A; char*c=FM(char,np),tit[1024],nt[32];
Face*F,*FL; fcinfo*I,*U,*V,*VL; double Max=ask(mwn,"max distance?","1e-5"); Max=Max*Max;
GetTitle(mwn,tit,256); j=0; altered=1;
LOOP: k=i=0; j++;
forface() forvert() if(i++,U=(V==I?VL:V)-1,P=U->p,Q=V->p,P!=Q) if((P->a-Q->a).rr()<=Max) {k++;
	 if(!(i&0x255)) {sprintf(nt,"%6d : %6d",j,nq-i); SetTitle(mwn,nt);}
	 if(KEYS[VK_ESCAPE]) goto WHOA; w=(P->a+Q->a)*.5; Q->a=w;
	 for(l=0;l<nq;l++) if(pts[l].p==P) pts[l].p=Q; break;}
sprintf(nt,"%6d",k); SetTitle(mwn,nt);
if(k) goto LOOP;
WHOA: SetTitle(mwn,tit); FF(c); /*FF(fp);*/ rerot=1;}
/*-----*/
xyz mesh::defcenter(){xyz S; int i; Face*F,*FL; fcinfo*I,*V,*VL;
S.x=S.y=S.z=i=0; forface() forvert() {S=S+V->p->r; i++;} if(i) S=S*(1./i); return S;}
/*-----*/
xyz dircos(xyz A,xyz B,xyz C);
double dihedral(xyz A,xyz B,xyz C,xyz D);
double dihedral(Face*F,Face*G);
//void prxyz(FILE*F,xyz p,int n=0){fprintf(F,"{%12g,%12g,%12g}%c",p.x,p.y,p.z,n?' ':'\n');}
void facerotf(Face*F){fcinfo*I=F->q,A; if(I) if(F->n==3) {A=I[0]; I[0]=I[1]; I[1]=I[2]; I[2]=A;}}
void facerotb(Face*F){fcinfo*I=F->q,A; if(I) if(F->n==3) {A=I[0]; I[0]=I[2]; I[2]=I[1]; I[1]=A;}}
/*-----*/// thin out the faces
void mesh::weldall3(){long i,i1,i2,itable,j,k,l,m,n,p1,p2,NF,NV,na1,na2,antip;
xyz p,w,A; xy tu,tv,t0(0,0); fcinfo*I,*J,*K,*U,*V,*W,*X,*VL,*Itable,*Ilimit; Face*A1[1024],*A2[1024];
double dl,z; char tit[1024],nt[32],tg; Face*F,*FL,*G; Point*P,*Q;
Face*FT=triangularize(); collectgarbage(); other=FM(long,nq);
dl=ask(mwn,"max angle allowed to move a face by at each iteration? (deg)","3");
GetTitle(mwn,tit,256); j=0; altered=1; collectgarbage();
LOOP: Itable=FT->q; Ilimit=pts+nq; checkedges(0,1,1); // Here we don't want other deleting!!!!
forallface() forvert() V->p->c=0; /* don't move vertex if:- */
forallface() forvert() if(V->c!=2) V->p->c=(V==VL-1?I:V+1)->p->c=1; /* it is on a funny edge */
forallface() if(!F->s) forvert() V->p->c=1; /* it is on an unselected face */ k=i=0; j++;
for(NF=FT-fac;NF<nf;NF++) if(F=fac+NF,F->s) for(VL=I+3,NV=0;NV<3;NV++) {
	 I=F->q; if(!I) continue; V=I+NV; FL=fac+nf;
	 i++; p1=NV; U=I+(p1+1)%3; P=V->p; Q=U->p; if(P==Q) continue;
	 i1=V-pts; tu.x=tu.y=tv.x=tv.y=0; if(i1<0?1:i1>=nq) continue;
	 i2=other[i1]; itable=Itable-pts; if(i2<0?1:i1<i2?1:i2<itable?1:i2>=nq) continue;
	 Face*F1=F,*F2=FT+(m=i2-itable)/3; if(l=F2-fac,l<0?1:l>=nf) continue;
	 p2=m%3; J=F2->q; if(!J) continue; W=J+p2; X=J+(p2+1)%3;
	 if(V->p==W->p?U->p==X->p:0) antip=0; else if(V->p==X->p?U->p==W->p:0) antip=1; else continue;
	 char c1=P->c,c2=Q->c; int g1=F1->g,g2=F2->g,m1=F1->mat,m2=F2->mat;
	 if(P->c?1:Q->c?1:!F1->q?1:!F2->q) continue;
	 if(c1) if(c2) continue; else w=Q->a; else if(c2) w=P->a; else w=(P->a+Q->a)*.5;
	 for(na1=na2=0,G=FT;G<FL;G++) if(K=G->q,K) if(G->s) if(G!=F1) if(G!=F2) {
		  if(K[0].p==P) {if(na1<1023) {A1[na1++]=G;}} else
		  if(K[1].p==P) {if(na1<1023) {A1[na1++]=G; facerotf(G);}} else
		  if(K[2].p==P) {if(na1<1023) {A1[na1++]=G; facerotb(G);}}
		  if(K[0].p==Q) {if(na2<1023) {A2[na2++]=G;}} else
		  if(K[1].p==Q) {if(na2<1023) {A2[na2++]=G; facerotf(G);}} else
		  if(K[2].p==Q) {if(na2<1023) {A2[na2++]=G; facerotb(G);}}
		  if(na1) if(na2) if(A1[na1-1]==A2[na2-1]) {na1--; na2--;}}
	 for(n=0;n<na1;n++) if(G=A1[n],G) if(K=G->q,K) {
		  if(G->g  !=g1) if(G->g  !=g2) {c1=1; break;}
		  if(G->mat!=m1) if(G->mat!=m2) {c1=1; break;}
		  if(K->t!=V->t) if(K->t!=U->t) if(K->t!=W->t) if(K->t!=X->t) {c1=1; break;}}
	 for(n=0;n<na2;n++) if(G=A2[n],G) if(K=G->q,K) {
		  if(G->g  !=g1) if(G->g  !=g2) {c2=1; break;}
		  if(G->mat!=m1) if(G->mat!=m2) {c2=1; break;}
		  if(K->t!=V->t) if(K->t!=U->t) if(K->t!=W->t) if(K->t!=X->t) {c2=1; break;}}
	 tu=t0; tv=t0; tg=!V->t ?0: !U->t ?0: !W->t ?0: !!X->t;
	 if(c1?0:!c2) {w=(P->a+Q->a)*.5; if(tg) {tu=(V->t->a+U->t->a)*.5; tv=(W->t->a+X->t->a)*.5;}
		  for(n=0;n<na1;n++) if(G=A1[n],G) {z=180-dihedral(G->q[1].p->a,G->q[2].p->a,G->q[0].p->a,w); if(z>dl) goto L4;}
		  for(n=0;n<na2;n++) if(G=A2[n],G) {z=180-dihedral(G->q[1].p->a,G->q[2].p->a,G->q[0].p->a,w); if(z>dl) goto L4;}}
	 else if(!c2) {w=P->a; if(tg) {tu=V->t->a; tv=(antip?X:W)->t->a;}
		  for(n=0;n<na2;n++) if(G=A2[n],G) {z=180-dihedral(G->q[1].p->a,G->q[2].p->a,G->q[0].p->a,w); if(z>dl) goto L4;}}
	 else if(!c1) {w=Q->a; if(tg) {tu=U->t->a; tv=(antip?W:X)->t->a;}
		  for(n=0;n<na1;n++) if(G=A1[n],G) {z=180-dihedral(G->q[1].p->a,G->q[2].p->a,G->q[0].p->a,w); if(z>dl) goto L4;}}
	 else L4: continue;
	 k++; if(!(i&255)) {sprintf(nt,"%6d : %6d",j,nq-i); SetTitle(mwn,nt);} if(KEYS[VK_ESCAPE]) goto WHOA;
	 P->a=w; Q->a=w; P->c=Q->c=P->c|Q->c; // what about the vn's?
	 if(U->t) U->t->a=tu; if(V->t) V->t->a=tu; if(W->t) W->t->a=tv; if(X->t) X->t->a=tv;
	 for(K=Itable;K<Ilimit;K++) if(K->p==P) K->p=Q;
	 {long F1i=F1->q-pts,O1=other[F1i+(p1+1)%3],O2=other[F1i+(p1+2)%3]; other[O1]=O2; other[O2]=O1; other[F1i+p1%3]=-1;
	  long F2i=F2->q-pts,O3=other[F2i+(p2+1)%3],O4=other[F2i+(p2+2)%3]; other[O3]=O4; other[O4]=O3; other[F2i+p2%3]=-1;}
	 for(n=0;n<na1;n++) {G=A1[n]; K=G->q; K->p=Q; if(K->t==V->t) K->t=U->t; else if(K->t==X->t) K->t=W->t;}
	 for(n=0;n<na2;n++) {G=A2[n]; K=G->q; K->p=Q; if(K->t==V->t) K->t=U->t; else if(K->t==X->t) K->t=W->t;}
	 F1->q=F2->q=0; /*ENDLOOP:;*/}
sprintf(nt,"%6d faces removed",k); SetTitle(mwn,nt); n=MessageBox(0,nt,"do you want me to continue?",MB_YESNO);
if(n==IDYES) goto LOOP;
WHOA: SetTitle(mwn,tit); deledgeinfo(); rerot=1;}
/*-----*/// weld all close points on the texture map
void mesh::weldallt(){long i,j; Point*p; xy T; char*c=FM(char,nq),tit[1024],nt[32];
Face*F,*FL; fcinfo*I,*V,*VL;
double Maxt=ask(mwn,"max distance on texture map?","1e-5"); Maxt=Maxt*Maxt;
double Max=ask(mwn,"max distance on mesh?","1e-5"); Max=Max*Max;
for(i=0;i<nq;i++) c[i]=0; forface() forvert() if(V->t) c[V-pts]=1; GetTitle(mwn,tit,256);
for(i=nq-1;i>=0;i--) if(c[i]) {T=pts[i].t->a;
	 if(!(i&255)) {sprintf(nt,"%6d",i); SetTitle(mwn,nt);} p=pts[i].p;
	 for(j=0;j<i;j++) if(c[j]) if((p->a-pts[j].p->a).rr()<Max) if((T-pts[j].t->a).rr()<=Maxt) {
		  c[j]=0; pts[j].t=pts[i].t;}}
SetTitle(mwn,tit); FF(c); altered=1;}
/*-----*/// weld all close points on the texture map if they are at the same vertex
void mesh::weldtatp(){long i,j; Point*p; xy T; char*c=FM(char,nq),tit[1024],nt[32];
Face*F,*FL; fcinfo*I,*V,*VL; double Max=ask(mwn,"max distance on texture map?","1e-5"); Max=Max*Max;
for(i=0;i<nq;i++) c[i]=0; forface() forvert() if(V->t) c[V-pts]=1; GetTitle(mwn,tit,256);
for(i=nq-1;i>=0;i--) if(c[i]) {T=pts[i].t->a;
	 if(!(i&255)) {sprintf(nt,"%6d",i); SetTitle(mwn,nt);} p=pts[i].p;
	 for(j=0;j<i;j++) if(c[j]) if(p==pts[j].p) if((T-pts[j].t->a).rr()<=Max) {
		  c[j]=0; pts[j].t=pts[i].t;}}
SetTitle(mwn,tit); FF(c); altered=1;}
/*-----*/// give different UV points to all face-corners that are at vertex p
void mesh::unweldtex(long p) {Face*F,*FL; fcinfo*I,*V,*VL; if(p<0) return; int j,n=0;
Point*P=&point[p]; altered=1;
forallface() forvert() if(V->p==P) if(V->t) n++; j=nt; if(!setnt_(j+n)) return;
forallface() forvert() if(V->p==P) if(V->t) {V->t=t+j; t[j++]=*V->t;} nt=j; collectgarbaget();}
/*-----*/// give different UV points to all face-corners that are at UV point p
void mesh::unweldtext(long p) {Face*F,*FL; fcinfo*I,*V,*VL; if(p<0?1:p>=nt) return;
int j,n=0; altered=1;
forallface() forvert() if(V->t) if(V->t-t==p) n++; j=nt; if(!setnt_(j+n)) return; Texp P=t[p];
forallface() forvert() if(V->t) if(V->t-t==p) {V->t=t+j; t[j++]=P;} nt=j; collectgarbaget();}
/*-----*/
void mesh::findtmas(){char tit[1024],Nt[256]; GetTitle(mwn,tit,256); collectgarbage();
long i,m,ni=0,*pt=FM(long,nt+1); Face*F,*FL; fcinfo*I,*V,*VL;
ntma=0; forallface() F->tma=-1; for(i=0;i<nt;i++) pt[i]=-1;
forallface() {forvert() if(V->t) goto L3; F->tma=0; L3:;} ntma=1;
AGAIN: sprintf(Nt,"%6d texture map areas found, %ld iterations",ntma,ni); SetTitle(mwn,Nt);
forallface() if(F->tma==-1) goto BLANK;
SetTitle(mwn,tit); if(pt) FF(pt); if(tma) FF(tma); tma=FM(Tma,ntma); ntma_=ntma; for(i=0;i<ntma;i++) tma[i].vis=1; return;
BLANK: F->tma=(short)ntma; m=1; ni=0; forvert() if(V->t) pt[V->t-t]=ntma; ni++;
while(m) {m=0;
	 forallface() if(F->tma==-1) {
		  forvert() if(V->t) if(pt[V->t-t]==ntma) goto L2; continue;
		  L2: F->tma=(short)ntma; forvert() if(V->t) pt[V->t-t]=ntma; m++;}}
ntma++; goto AGAIN;}
/*-----*/
void mesh::findprts(double angle){Face*F,*FL,*G; fcinfo*I,*V,*VL; char tit[1024],Nt[32];
long i,l,m,o,prtn; char*X,*Y; nprt=0; GetTitle(mwn,tit,256); findedges();
X=FM(char,nf); Y=FM(char,nf); prtn=0; for(i=0;i<nf;i++) X[i]=Y[i]=-1;
NEXTPRT: for(l=0;l<nf;l++) if(fac[l].q) if(X[l]==-1) goto BLANK; goto WHOA;
BLANK: sprintf(Nt,"%6d parts found",prtn); SetTitle(mwn,Nt); X[l]=0; Y[l]=char(fac[l].prt=(short)prtn);
LOOP: m=0;
forallface() if(!X[F-fac]) {X[F-fac]=1;
	 forvert() if(V->c==2) if(l=other[V-pts],l>=0) {double w;
		  if(!angle) w=-1;
		  else {G=&fac[feinfo[l].k]; w=dihedral(F,G);}
		  if(w<angle) {o=feinfo[l].k; if(X[o]<0) {Y[o]=char(fac[o].prt=(short)prtn); X[o]=0; m++;}}}}
if(m) goto LOOP; prtn++; i=addprt(); prt[i].vis=1; goto NEXTPRT;
WHOA: FF(X); FF(Y); deledgeinfo(); SetTitle(mwn,tit);}
/*-----*/
inline double det(double a,double b,double c,double d,double e,double f,double g,double h,double i) {
return a*(e*i-f*h)+b*(f*g-d*i)+c*(d*h-e*g);}
/*-----*/
xyz dircos_(xyz A,xyz B,xyz C){
double x=det(  1,A.y,A.z,   1,B.y,B.z,   1,C.y,C.z);
double y=det(A.x,  1,A.z, B.x,  1,B.z, C.x,  1,C.z);
double z=det(A.x,A.y,  1, B.x,B.y,  1, C.x,C.y,  1);
return xyz(x,y,z);}
/*-----*/
xyz dircos(xyz A,xyz B,xyz C){xyz d=dircos_(A,B,C); double r=d.rr();
if(r<1e-5) {A.x+=1; B.x+=1; C.x+=1; d=dircos_(A,B,C); r=d.rr();}
if(r<1e-5) {A.y+=1; B.y+=1; C.y+=1; d=dircos_(A,B,C); r=d.rr();}
if(r<1e-5) {A.z+=1; B.z+=1; C.z+=1; d=dircos_(A,B,C); r=d.rr();}
return d*(r?1/sqrt(r):1);}
/*-----*/
#if 0
xyz dircos_(Face*F,xyz d){int i,n=F->n; xyz p; double sx=0,sy=0,sz=0,sxx=0,syy=0,szz=0,sxy=0,syz=0,szx=0,x,y,z,r;
for(i=0;i<n;i++) {p=F->q[i].p->a+d; sx+=p.x; sy+=p.y; sz+=p.z;
	 sxx+=p.x*p.x; syy+=p.y*p.y; szz+=p.z*p.z; sxy+=p.x*p.y; syz+=p.y*p.z; szx+=p.z*p.x;}
r=det(sxx,sxy,szx, sxy,syy,syz, szx,syz,szz); if(r<1e-12) return xyz(0,0,0);
x=det(sx ,sxy,szx, sy ,syy,syz, sz ,syz,szz);
y=det(sxx,sx ,szx, sxy,sy ,syz, szx,sz ,szz);
z=det(sxx,sxy,sx , sxy,syy,sy , szx,syz,sz );
return xyz(x,y,z);}
/*-----*/
xyz dircos(Face*F){int n=F->n; xyz d; double r;
if(n==3) return dircos(F->q[0].p->a,F->q[1].p->a,F->q[2].p->a);
d=dircos_(F,xyz(0,0,0)); r=d.rr();
if(r<1e-6) {d=dircos_(F,xyz(1,0,0)); r=d.rr();}
if(r<1e-6) {d=dircos_(F,xyz(1,1,0)); r=d.rr();}
if(r<1e-6) {d=dircos_(F,xyz(1,1,1)); r=d.rr();}
return d*(r?1/sqrt(r):1);}
#endif
/*-----*/
xyz dircos(Face*F){int i,n=F->n; xyz c,d,e; double r;
if(n==3) return dircos(F->q[0].p->a,F->q[1].p->a,F->q[2].p->a);
c.x=c.y=c.z=0; for(i=0;i<n;i++) c+=F->q[i].p->a; c=c*(1./n);
e.x=e.y=e.z=0; for(i=0;i<n;i++) e=e+dircos(F->q[i].p->a,F->q[(i+1)%n].p->a,c); r=e.rr();
return e*(r?1/sqrt(r):1);}
/*-----*/
//double scprod(xyz a,xyz b){return a.x*b.x+a.y*b.y+a.z*b.z;}
/*-----*/
static double pi=0;
/*-----*/
double pythag(xyz C,xyz P,xyz E) {double pc=(P-C).rr(),pe=(P-E).rr(),r;
if(!pc?1:!pe) return pi; r=(pc+pe-(C-E).rr())/2/sqrt(pc*pe);
return acos(r<-1?-1:r>1?1:r);}
/*-----*/
double dircos_angle(xyz A,xyz B) {if(!pi) pi=4*atan(1.); return pythag(A,xyz(0,0,0),B)*180/pi;}
/*-----*/
double dihedral(xyz A,xyz B,xyz C,xyz D) {return dircos_angle(dircos(A,B,C),dircos(A,D,B));}
/*-----*/
//double dihedral2(xyz A,xyz B,xyz C,xyz D) {double w; if(!pi) pi=4*atan(1.);
//double r=(B-A).rr(); if(!r) return 0;
//double p=scprod(B-A,B-C)/r,q=scprod(B-A,B-D)/r;
//xyz P=A*p+B*(1-p),Q=A*q+B*(1-q);
//w=fabs(pi-pythag(C,P,D+P-Q)); while(w>pi) w-=2*pi;
//return fabs(w);}
/*-----*/
double dihedral(Face*F,Face*G) {return dircos_angle(dircos(F),dircos(G));}
/*-----*/
void mesh::detriang(int noask){
int i,j,k,l,m,n,o,p; Face*F,*G; fcinfo*J,*K,a[4]; char L[64];
double max=ask(mwn,"max angle (deg) allowed between faces to be joined?","4");
collectgarbage(); p=nf; altered=1; setnf_(nf+nf/2+16); setnq_(2*nq);
for(i=1;i<nf;i++)
  if(F=fac+i,J=F->q,J) if(F->s) if(F->n==3)
  if(G=F-1,  K=G->q,K) if(G->s) if(G->n==3) if(F->mat==G->mat) if(F->g==G->g) if(K==J-3) {
	 for(j=0;j<3;j++) for(k=0;k<3;k++)
		 if(J[j].p==K[k].p) if(J[l=(j+1)%3,l].p==K[m=(k+2)%3,m].p) goto L1; continue;
L1: if(J[j].t!=K[k].t ?1: J[l].t!=K[m].t) continue;
	 if(J[n=(j+2)%3,n].p==K[o=(k+1)%3,o].p) continue;
	 if(dihedral(F,G)>max) continue;
//	 if(dihedral(J[j].p->a,J[l].p->a,J[n].p->a,K[o].p->a)>max) continue;
//	 if(dihedral(J[n].p->a,K[o].p->a,J[j].p->a,J[l].p->a)>max) continue;
	 a[0]=J[j]; a[1]=K[o]; a[2]=J[l]; a[3]=J[n];
	 K[0]=a[0]; K[1]=a[1]; K[2]=a[2]; K[3]=a[3]; G->n=4; F->q=0; F->s=0; p--;}
if(noask) return; sprintf(L,"there were %d faces; now there are %d",nf,p); i=nd?MB_YESNO:MB_OK;
j=MessageBox(0,nd?"shall I remove the normals (vn lines) to save more space?":"",L,i);
if(!nd) j=IDNO;
if(j==IDYES) {for(i=0;i<nq;i++) pts[i].d=0; nd=0; FF(d);}
checkedges();}
/*-----*/
void mesh::detriang2(HWND wn,int noask){
int h,i,j,p; Face*F,*G; fcinfo*H,*J,*K,a,b,c,d; char L[64],T[1024]; xyz A,B,C,D; double pi=4*atan(1.);
double max=ask(mwn,"max angle (deg) allowed between faces to be joined?","4");
double maxangdev=ask(mwn,"max angle (deg) variation from 90 allowed for new angles?","20")*pi/180;
collectgarbage(); p=nf; altered=1; setnf_(nf+nf/2+16); setnq_(2*nq); GetTitle(wn,T,512);
for(i=0;i<nf-1;i++) if(G=fac+i,K=G->q,K) if(G->s) if(G->n==3) {
	 if(!((nf-i)%100)) {sprintf(L,"%d",nf-i); SetTitle(wn,L);}
	 for(h=i+1;h<nf;h++) if(F=fac+h,J=F->q,J) if(F->s) if(F->n==3) if(F->mat==G->mat) if(F->g==G->g) {
		  if(J[0].p==K[0].p) if(J[1].p==K[2].p) if(J[0].t==K[0].t) if(J[1].t==K[2].t) {a=J[1]; b=J[2]; c=J[0]; d=K[1]; goto L1;}
		  if(J[0].p==K[1].p) if(J[1].p==K[0].p) if(J[0].t==K[1].t) if(J[1].t==K[0].t) {a=J[1]; b=J[2]; c=J[0]; d=K[2]; goto L1;}
		  if(J[0].p==K[2].p) if(J[1].p==K[1].p) if(J[0].t==K[2].t) if(J[1].t==K[1].t) {a=J[1]; b=J[2]; c=J[0]; d=K[0]; goto L1;}
		  if(J[1].p==K[0].p) if(J[2].p==K[2].p) if(J[1].t==K[0].t) if(J[2].t==K[2].t) {a=J[2]; b=J[0]; c=J[1]; d=K[1]; goto L1;}
		  if(J[1].p==K[1].p) if(J[2].p==K[0].p) if(J[1].t==K[1].t) if(J[2].t==K[0].t) {a=J[2]; b=J[0]; c=J[1]; d=K[2]; goto L1;}
		  if(J[1].p==K[2].p) if(J[2].p==K[1].p) if(J[1].t==K[2].t) if(J[2].t==K[1].t) {a=J[2]; b=J[0]; c=J[1]; d=K[0]; goto L1;}
		  if(J[2].p==K[0].p) if(J[0].p==K[2].p) if(J[2].t==K[0].t) if(J[0].t==K[2].t) {a=J[0]; b=J[1]; c=J[2]; d=K[1]; goto L1;}
		  if(J[2].p==K[1].p) if(J[0].p==K[0].p) if(J[2].t==K[1].t) if(J[0].t==K[0].t) {a=J[0]; b=J[1]; c=J[2]; d=K[2]; goto L1;}
		  if(J[2].p==K[2].p) if(J[0].p==K[1].p) if(J[2].t==K[2].t) if(J[0].t==K[1].t) {a=J[0]; b=J[1]; c=J[2]; d=K[0]; goto L1;}
		  continue;
//**/sprintf(L,"testing faces %d & %d",h,i); MessageBox(0,L,"detriang2",OUCH);
L1:	  if((dihedral(F,G))>max) continue;
//**/sprintf(L,"dihedral=%g",w); MessageBox(0,L,"detriang2",OUCH); // o and n used before set; k unused *********
		  A=a.p->a; B=b.p->a; C=c.p->a; D=d.p->a;
//**/sprintf(L,"new angles=%g,%g",pythag(B,A,D)*180/pi,pythag(B,C,D)*180/pi); MessageBox(0,L,"detriang2",OUCH);
		  if(fabs(pi/2-pythag(B,A,D))>maxangdev?1:fabs(pi/2-pythag(B,C,D))>maxangdev) continue;
		  /* setnq_(nq+4);*/ H=pts+nq; nq+=4; /*K=G->q;*/
//	 if(dihedral(J[j].p->a,J[l].p->a,J[n].p->a,K[o].p->a)>max) continue;     #########
//	 if(dihedral(J[n].p->a,K[o].p->a,J[j].p->a,J[l].p->a)>max) continue;
		  H[0]=a; H[1]=b; H[2]=c; H[3]=d; G->q=H; G->n=4; F->q=0; F->s=0; p--; goto L2;}
L2:; }
if(noask) return; sprintf(L,"there were %d faces; now there are %d",nf,p); i=nd?MB_YESNO:MB_OK;
j=MessageBox(0,nd?"shall I remove the normals (vn lines) to save more space?":"",L,i);
if(!nd) j=IDNO;
if(j==IDYES) {for(i=0;i<nq;i++) pts[i].d=0; nd=0; FF(d);}
SetTitle(wn,T); checkedges();}
/*-----*/
int mesh::dereentrant(long f,double max){Face*F,*G; if(f<0?1:f>=nf) return 0;
fcinfo*I,*J; int i,j,n,N=0; double w/*,pi=4*atan(1.)*/; xyz mid;
LOOP: F=&fac[f]; n=F->n; I=F->q; if(!I?1:n<4) return N; mid=xyz(0,0,0);
for(i=0;i<n;i++) mid=mid+I[i].p->a; altered=1;
for(i=0;i<n;i++) {
	w=dihedral(I[(i+n-1)%n].p->a,I[(i+1)%n].p->a,I[i].p->a,(mid-I[i].p->a)*(1./(n-1)));
	if(w>max) goto FOUND;} return N;
FOUND: G=addface(3); F=&fac[f]; I=F->q; J=G->q; J[0]=I[(i+n-1)%n]; J[1]=I[i]; J[2]=I[(i+1)%n];
G->mat=F->mat; G->g=F->g; G->tma=F->tma; G->prt=F->prt;
for(j=i+1;j<n;j++) I[j-1]=I[j]; F->n--; N++; goto LOOP;}
/*-----*/
int mesh::markreentrant(long f,double max){Face*F; if(f<0?1:f>=nf) return 0;
fcinfo*I; int i,n; double w/*,pi=4*atan(1.)*/; xyz mid;
F=&fac[f]; n=F->n; I=F->q; if(!I?1:n<4) return 0; mid=xyz(0,0,0);
for(i=0;i<n;i++) mid=mid+I[i].p->a; altered=1;
for(i=0;i<n;i++) {
    w=dihedral(I[(i+n-1)%n].p->a,I[(i+1)%n].p->a,I[i].p->a,(mid-I[i].p->a)*(1./(n-1)));
	 if(w>max) goto FOUND;} return 0;
FOUND: OB->fac[i].s=1; return 1;}
/*------*//*does the line D-E go through the triangle A-B-C? */
int triline(xyz A,xyz B,xyz C,xyz D,xyz E,xyz&R,double&a,double&b,double&c,double&d,double limit){
double aaa,bbb,ccc,w; R.x=R.y=R.z=a=b=c=d=0;
w=max(max((A-B).rr(),(B-C).rr()),max((C-A).rr(),(D-E).rr()));
double det=eqnsolve3(A.x-C.x,B.x-C.x,E.x-D.x,E.x-C.x,
							A.y-C.y,B.y-C.y,E.y-D.y,E.y-C.y,
							A.z-C.z,B.z-C.z,E.z-D.z,E.z-C.z,a,b,d); if(!det) return 0;
double ab=a+b,bc=1-a,ca=1-b; c=1-a-b; w=w*limit*limit;
R=D*d+E*(1-d);
if((R-A).rr()<w) R=A;
if((R-B).rr()<w) R=B;
if((R-C).rr()<w) R=C;
if((R-D).rr()<w) R=D;
if((R-E).rr()<w) R=E;
aaa=((bc?(B*b+C*c)/bc:(B+C)*.5)-A).rr();
bbb=((ca?(C*c+A*a)/ca:(C+A)*.5)-B).rr();
ccc=((ab?(A*a+B*b)/ab:(A+B)*.5)-C).rr();
if(a*a*aaa<limit) {a=0;} else if(bc*bc*aaa<limit) {a=1;}
if(b*b*bbb<limit) {b=0;} else if(ca*ca*bbb<limit) {b=1;}
if(c*c*ccc<limit) {c=0;} else if(ab*ab*ccc<limit) {c=1;}
if((E-R).rr()<limit) {d=0; R=E;} else if((D-R).rr()<limit) {d=1;}
if(d<0?1:d>1?1:a<0?1:b<0?1:c<0) return 0; return 1;}
/*-----*/
int mesh::triangorder(Face*F,xyz(*t)[3]){fcinfo*I; int c=0,i,j,n=F->n; double w; xyz mid;
double*W=FM(double,n); xyz*K=FM(xyz,n); I=F->q; for(i=0;i<n;i++) K[i]=I[i].p->a;
LOOP: if(!I?1:n<4) {t[c][0]=K[0]; t[c][1]=K[1]; t[c][2]=K[2]; FF(K); FF(W); return c+1;}
mid=xyz(0,0,0); for(i=0;i<n;i++) {mid=mid+I[i].p->a;}
for(i=0;i<n;i++) W[i]=dihedral(K[(i+n-1)%n],K[(i+1)%n],K[i],(mid-K[i])*(1./(n-1)));
for(w=-1e30,i=j=0;j<n;j++) if(w<W[j]) w=W[i=j];
t[c][0]=K[(i+n-1)%n]; t[c][1]=K[i]; t[c++][2]=K[(i+1)%n];
for(j=i+1;j<n;j++) K[j-1]=K[j]; n--; goto LOOP;}
/*-----*/
Face*mesh::triangularize(){fcinfo*I,*J,*V,*VL,*K; Face*F,*FL,*G,*H,*Tr; int i,nfs,nqs,nnfs,nnqs;
forallface() if(F->n<3) F->q=0; altered=1;
nfs=nqs=nnfs=0; forface() {nfs++; nqs+=F->n; nnfs+=(F->n-2);} nnqs=nnfs*3;
nf_=nf+nnfs-nfs; G=H=FM(Face,nf_); nq_=nq+nnqs-nqs; J=K=FM(fcinfo,nq_);
forallface() if(!F->s) {*H=*F; H++->q=J; forvert() *J++=*V;} Tr=H;
forallface() if(F->s) for(i=2;i<F->n;i++) {
	 *H=*F; H->n=3; H->s=1; H->q=J; J[0]=I[0]; J[1]=I[i-1]; J[2]=I[i]; H++; J+=3;}
FF(fac); FF(pts); fac=G; pts=K; nf_=nf=H-fac; nq_=nq=J-pts; return Tr;}
/*-----*/
void mesh::triangularize(int Fn){fcinfo*I,*J; Face*F=fac+Fn,*H; int i,n=F->n;
if(n<3) F->q=0; if(n==3) return; I=F->q; if(!I) return; altered=1;
setnf_(nf+n-2); setnq_(nq+3*(n-2)); F=fac+Fn; H=fac+nf; J=pts+nq;
for(i=2;i<F->n;i++){*H=*F; H->n=3; H->s=1; H->q=J; J[0]=I[0]; J[1]=I[i-1]; J[2]=I[i]; H++; J+=3;}
nf=H-fac; nq=J-pts; F->q=0;}
/*-----*/
Face*mesh::depentagon(){fcinfo*I,*J,*V,*VL,*K; Face*F,*FL,*G,*H,*Tr; int i,nfs,nqs,nnfs,nnqs;
forallface() if(F->n<3) F->q=0; altered=1;
nfs=nqs=nnfs=0; forallface() {nfs++; nqs+=F->n; nnfs+=((F->n+3)/2-2);} nnqs=nnfs*4;
nf_=nf+nnfs-nfs; G=H=FM(Face,nf_); nq_=nq+nnqs-nqs; J=K=FM(fcinfo,nq_);
forallface() if(!F->s) {*H=*F; H++->q=J; forvert() *J++=*V;} Tr=H;
forallface() if(F->s) {
    for(i=3;i<F->n;i+=2) {
        *H=*F; H->n=4; H->s=1; H->q=J; J[0]=I[0]; J[1]=I[i-2]; J[2]=I[i-1]; J[3]=I[i]; H++; J+=4;}
    if(F->n&1) {
		  *H=*F; H->n=3; H->s=1; H->q=J; J[0]=I[0]; J[1]=I[i-2]; J[2]=I[i-1]; H++; J+=3;}}
FF(fac); FF(pts); fac=G; pts=K; nf_=nf=H-fac; nq_=nq=J-pts; checkedges(); return Tr;}
/*-----*/
void mesh::fillhollows(){int i,j; collectgarbage(); int*N=FM(int,np),*nn=FM(int,np);
Face*F,*FL; fcinfo*I,*U,*V,*VL; double r,*A=FM(double,np);
xyz a,b,c,u,v,*norm=FM(xyz,np),*n2=FM(xyz,np),*sneigh=FM(xyz,np),*old=FM(xyz,np),ooo(0,0,0),dp,W;
for(i=0;i<np;i++) point[i].c=0; altered=1;
forallface() if(F->s) forvert() V->p->c|=1; else forvert() V->p->c|=2; // find in / out / edge points
for(i=0;i<np;i++) old[i]=point[i].a; // save old values
for(i=0;i<np;i++) {A[i]=N[i]=nn[i]=0; norm[i]=ooo; sneigh[i]=ooo;}
forfaces(OB) forvert() {j=V->p-OB->point; dp=F->normal(V-I); r=dp.rr(); if(r) {N[j]++; norm[j]+=dp;}}
for(i=0;i<np;i++) n2[i]=ooo;
forfaces(OB) forvert() {U=V==I?VL-1:V-1; i=U->p-OB->point; j=V->p-OB->point; n2[i]+=norm[j]; n2[j]+=norm[i];}
for(i=0;i<np;i++) {r=n2[i].rr(); norm[i]=!r?ooo:n2[i]*(1/sqrt(r));} // norm := vector to move along
forfaces(OB) forvert() {U=V==I?VL-1:V-1;
	 v=V->p->a; i=V->p-OB->point; u=U->p->a; j=U->p-OB->point; sneigh[i]=sneigh[i]+u; sneigh[j]=sneigh[j]+v; nn[i]++; nn[j]++;}
for(i=0;i<np;i++) if(N[i]) if(r=norm[i].rr(),r) {A[i]=
	 (norm[i].x*(sneigh[i].x/nn[i]-OB->point[i].a.x)+
	  norm[i].y*(sneigh[i].y/nn[i]-OB->point[i].a.y)+
	  norm[i].z*(sneigh[i].z/nn[i]-OB->point[i].a.z)) / r;}
//for(i=0;i<np;i++) if(point[i].c==1) if(A[i]>0) point[i].a=point[i].a+norm[i]*A[i];
for(i=0;i<np;i++) if(point[i].c==1) if(A[i]>0) point[i].a=sneigh[i]*(1./nn[i]);
FF(N); FF(norm); FF(n2); FF(old); FF(sneigh); FF(A); rerot=1;}
/*-----*/
byte*setexcluder(byte*e) {return e;}
/*-----*/
void mesh::spacesuit(HWND wn){int i,j,k,n; collectgarbage(); byte*N=FM(byte,np); byte*E=FM(byte,np);
setexcluder(E); Face*F,*FL; fcinfo*I,*U,*V,*VL; Point*W; TempTitle tt(wn,"working out normals");
double r,th,eth=ask(wn,"thickness to add?",".005");
double dth=ask(wn,"increment step?",".005");
int nni=(int)ask(wn,"how many iterations of smoothing the normals?","30");
char ncx=MessageBox(0,"do you want to avoid changing the sign of x?","",MB_YESNO)==IDYES;
int et=MessageBox(0,"(cancel = put a step along the edge)","shall I move the edge points?",
  MB_YESNOCANCEL);
xyz a,b,c,*norm=FM(xyz,np),*n2=FM(xyz,np),*old=FM(xyz,np),ooo(0,0,0),dp; char bust[256];
for(i=0;i<np;i++) point[i].c=0; altered=1;
forallface() if(F->s) forvert() V->p->c|=1; else forvert() V->p->c|=2; // find in / out / edge points
for(i=0;i<np;i++) old[i]=point[i].a;
if(dth>0) for(th=0;th<eth;th+=dth) {
	 for(i=0;i<np;i++) {N[i]=0; norm[i]=ooo;}
	 forfaces(OB) forvert() {j=V->p-OB->point; dp=F->normal(V-I); r=dp.rr(); if(r) {N[j]++; norm[j]+=dp;}}
	 for(k=0;k<nni;k++) {sprintf(bust,"%g:%d",eth-th,nni-k); SetTitle(wn,bust);
		  for(i=0;i<np;i++) n2[i]=ooo;
		  forfaces(OB) forvert() {U=V==I?VL-1:V-1; i=U->p-OB->point; j=V->p-OB->point; n2[i]+=norm[j]; n2[j]+=norm[i];}
		  for(i=0;i<np;i++) {r=n2[i].rr(); norm[i]=!r?ooo:n2[i]*(1/sqrt(r));}}
	 for(i=0;i<np;i++) if(N[i]) if(r=norm[i].rr(),r) {
		  dp=norm[i]*(dth/sqrt(r)); xyz&p=OB->point[i].a;
		  if(ncx) if(dp.x*p.x<0) if(dp.x*dp.x>p.x*p.x) continue; /* option to avoid mess at human model's perineum */
		  /* if(E[i])*/ p=p+dp;}}
if(et==IDNO) for(i=0;i<np;i++) if(point[i].c==3) point[i].a=old[i];
if(et==IDCANCEL) {setnp_(2*np); for(i=0;i<nq;i++) pts[i].e=0;
	 for(j=np,i=0;i<np;i++) {point[j+i].a=old[i]; point[j+i].c=point[j+i].h=0;}
	 forallface() if(!F->s) forvert() V->p+=np;
	 n=0; forface() forvert() {U=V+1; if(U==VL) U=I; if(U->p->c==3) if(V->p->c==3) {V->e=1; n++;}}
	 setnf_(nf+n); setnq_(nq+4*n); Face*G=&fac[nf]; fcinfo*J=&pts[nq]; W=&point[np];
	 forface() forvert() if(V->e) {U=V+1; if(U==VL) U=I; *G=*F; G->q=J; G->n=4;
		  *J++=*U; *J++=*V; *J=*V; if(J->p<W) J->p+=np; J++; *J=*U; if(J->p<W) J->p+=np; J++; G++;}
	 k=nf; nf+=n; nq+=4*n; np*=2; checkedges(); j=addprt();
	 for(F=fac+k,FL=fac+nf;F<FL;F++) if(F->s) if(I=F->q,I) {F->prt=j; forvert() if(V->c==4) {F->q=0; break;}}
	 collectgarbage();}
FF(N); FF(norm); FF(n2); FF(E); FF(old); rerot=1;}
/*-----*/
void mesh::duplfac(int rev){int i,j,k,p; Point**P; fcinfo**K,*I,*V,*VL,*U,*J; Face*F,*FL,*G;
short newg=MessageBox(0,"shall I put the new faces in new groups?","copying",MB_YESNO)==IDYES;
short newm=MessageBox(0,"shall I put the new faces in new materials?","copying",MB_YESNO)==IDYES;
checkedges(); k=0; forface() forvert() if(V->c==1) k++; /* count the loose edges */
forallface() if(!F->s) forvert() V->c=2;
setnf_(2*nf+k+16); setnq_(2*nq+4*k+16); setnp_(2*np+16); altered=1;
if(newg) {j=OB->ng; for(i=0;i<j;i++) addgroup(OB->group[i].name); newg=j;}
if(newm) {j=OB->nmat; for(i=0;i<j;i++) addmat(0,OB->mat[i].name); newm=j;}
for(j=np,i=0;i<np;i++) point[j+i]=point[i];
for(j=nq,i=0;i<nq;i++) {pts[j+i]=pts[i]; P=&pts[j+i].p; if(*P) *P+=np;}
for(j=nf,i=0;i<nf;i++) {fac[j+i]=fac[i]; K=&fac[j+i].q; if(*K) *K+=nq; fac[j+i].g+=newg; fac[j+i].mat+=newm;}
for(i=0;i<nf;i++) if(fac[i].s) fac[i].s=0; else fac[j+i].q=0;
G=&fac[2*nf]; J=&pts[2*nq]; p=rev?addprt():0;
forallface() forvert() if(V->c==1) {U=V+1; if(U==VL) U=I; *G=*F; G->n=4; G->q=J;
	 J[0]=*U; J[1]=*V; J[2]=V[nq]; J[3]=U[nq]; G->s=0; G->prt=p; G++; J+=4;}
if(rev) for(j=2*nf,i=nf;i<j;i++) if(fac[i].q) fac[i].turn();
nf=2*nf+(rev?k:0); nq=2*nq+(rev?4*k:0); while(G<fac+nf) G++->q=0;
np=2*np; collectgarbage(); checkedges();}
/*-----*/
void mesh::splitting(){int i,j=nf; Face*F; fcinfo*I,*U,*V,*VL;
for(i=0;i<j;i++) {F=fac+i; I=F->q; if(!I) continue;
    forvert() if(V->p->x) break; if(V==VL) continue;
    for(U=V+1;U<VL;U++) if(U->p->x) break; if(U==VL?1:U==V+1) continue; splitface(F,V-I,U-I);}}
/*-----*/
int mesh::splitatx(double w){Face*F,*FL; fcinfo*I,*V,*W,*VL; xyz p,q,r; double u,v,R;
setnp_(np+2*nq); setnt_(nt+2*nq); setnd_(nd+2*nq); setnq_(2*nq+2*nq); setnf_(nf*3);
char*C; C=check(); if(C) MessageBox(0,C,"bad mesh",OUCH);
int i=0,j; for(j=0;j<np;j++) point[j].x=0; int*fn=FM(int,nf); for(j=0;j<nf;j++) fn[j]=fac[j].n;
LOOP2: forface() forvert() {
	 W=V+1==VL?I:V+1; p=V->p->r; q=W->p->r; u=p.x; v=q.x;
	 R=u==v?9999:(u-w)/(u-v); if(R<-.0001?1:R>1.0001) continue; r=p+(q-p)*R; r.x=w;
	 if(R<.0001) {V->p->r.x=w; V->p->x=1; continue;}
	 if(R>.9999) {W->p->r.x=w; W->p->x=1; continue;} if(F->n>fn[F-fac]+4) continue;
	 j=OB->addpoint(fromscr(r)); if(j>=0) {point[j].r=r; point[j].x=1;}
	 FW[0].f=F-fac; FW[0].n=V-I; nFW=1; splitcurrentedge(j,1); i++; goto LOOP2;}
FF(fn); if(!i) {collectgarbage(); return 0;}
splitting(); C=check(); if(C) MessageBox(0,C,"bad mesh",OUCH); collectgarbage(); return 1;}
/*-w----*/
int mesh::splitaty(double w){Face*F,*FL; fcinfo*I,*V,*W,*VL; xyz p,q,r; double u,v,R; Point*P;
setnp_(np+2*nq); setnt_(nt+2*nq); setnd_(nd+2*nq); setnq_(2*nq+2*nq); setnf_(nf*3);
char*C; C=check(); if(C) MessageBox(0,C,"bad mesh",OUCH);
int i=0,j; for(j=0;j<np;j++) point[j].x=0; int*fn=FM(int,nf); for(j=0;j<nf;j++) fn[j]=fac[j].n;
LOOP2: forface() forvert() {
	 W=V+1==VL?I:V+1; p=V->p->r; q=W->p->r; u=p.y; v=q.y;
	 R=u==v?9999:(u-w)/(u-v); if(R<-.0001?1:R>1.0001) continue; r=p+(q-p)*R; r.y=w;
	 if(R<.0001) {V->p->r.y=w; V->p->x=1; continue;}
	 if(R>.9999) {W->p->r.y=w; W->p->x=1; continue;} if(F->n>fn[F-fac]+4) continue;
	 j=OB->addpoint(fromscr(r)); if(j>=0) {P=point+j; P->r=r; P->x=1;}
	 FW[0].f=F-fac; FW[0].n=V-I; nFW=1; splitcurrentedge(j,1); i++; goto LOOP2;}
FF(fn); if(!i) {collectgarbage(); return 0;}
splitting(); C=check(); if(C) MessageBox(0,C,"bad mesh",OUCH); collectgarbage(); return 1;}
/*-----*/
int mesh::splitatz(double w){Face*F,*FL; fcinfo*I,*V,*W,*VL; xyz p,q,r; double u,v,R;
setnp_(np+2*nq); setnt_(nt+2*nq); setnd_(nd+2*nq); setnq_(2*nq+2*nq); setnf_(nf*3);
char*C; C=check(); if(C) MessageBox(0,C,"bad mesh",OUCH);
int i=0,j; for(j=0;j<np;j++) point[j].x=0; int*fn=FM(int,nf); for(j=0;j<nf;j++) fn[j]=fac[j].n;
LOOP2: forface() forvert() {
	 W=V+1==VL?I:V+1; p=V->p->r; q=W->p->r; u=p.z; v=q.z;
	 R=u==v?9999:(u-w)/(u-v); if(R<-.0001?1:R>1.0001) continue; r=p+(q-p)*R; r.z=w;
	 if(R<.0001) {V->p->r.z=w; V->p->x=1; continue;}
	 if(R>.9999) {W->p->r.z=w; W->p->x=1; continue;} if(F->n>fn[F-fac]+4) continue;
	 j=OB->addpoint(fromscr(r)); if(j>=0) {point[j].r=r; point[j].x=1;}
	 FW[0].f=F-fac; FW[0].n=V-I; nFW=1; splitcurrentedge(j,1); funnyface(F-fac); i++; goto LOOP2;}
FF(fn); if(!i) {collectgarbage(); return 0;}
splitting(); C=check(); if(C) MessageBox(0,C,"bad mesh",OUCH); collectgarbage(); return 1;}
/*-----*/
char*mesh::splitface(int j,int k){
Point*S=point+j,*T=point+k; fcinfo*Q,*PP,*I,*V,*VL; Face*F,*G,*FL; int c=0,fc=0,i,l,n,u,v;
LOOP: for(F=fac+fc,FL=fac+nf;F<FL;F++) if(I=F->q,I) {
	 u=v=-1; forvert() if(V->p==S) u=V-I; else if(V->p==T) v=V-I;
	 if(u>=0) if(v>=0) goto FOUND;}
return c?0:"this split-a-face is not possible";
FOUND: fc=F-fac+1; n=F->n; if(u>v) {i=u; u=v; v=i;}
if(u==v?1:u+1==v?1:v-u==n-1) goto LOOP;
i=F-fac; if(!setnf_(nf+2) ?1: !setnq_(nq+n+2)) return "out of store";
F=fac+i; PP=pts+nq; Q=F->q; G=fac+nf++; *G=*F;
for(l=i=0;i<=u;i++) PP[l++]=Q[i]; PP[l-1].c=2;
for(i=v;i<n;i++) PP[l++]=Q[i]; G->q=PP; G->n=l;
PP+=l; nq+=l; for(l=0,i=u;i<=v;) PP[l++]=Q[i++]; PP[l-1].c=2;
G=fac+nf++; *G=*F; F->q=0; selface=-1; G->q=PP; G->n=l; nq+=l; altered=1;
c++; goto LOOP;}
/*-----*/
xyz tt[512][3]; char tt_[512];
/*-----*/// P := the intersction, it is at (1-s)*a+s*b
int mesh::intersection(Face*F,Point*a,Point*b,xyz&Q){int i,j,n=F->n; fcinfo*I=F->q; if(!I) return 0;
xyz u=a->a,v=b->a; double s,pi=4*atan(1.);
for(i=2;i<n;i++) {j=intersection(I[0].p->a,I[i-1].p->a,I[i].p->a,u,v,Q); if(j) break;}
s=xyangle(Q,I[n-1].p->a,I[0].p->a); for(i=1;i<n;i++) s+=xyangle(Q,I[i-1].p->a,I[i].p->a);
if(s>.999*2*pi) return j; return 0;}
/*-----*/
int mesh::intersection(xyz a,xyz b,xyz c,xyz u,xyz v,xyz&Q){double A,B,C,D,w,s,pi=4*atan(1.); // Ax+By+Cz+D=0;
if((u-v).rr()<1e-20) return 0;
A=(b.y-a.y)*(c.z-a.z)-(c.y-a.y)*(b.z-a.z);
B=(b.z-a.z)*(c.x-a.x)-(c.z-a.z)*(b.x-a.x);
C=(b.x-a.x)*(c.y-a.y)-(c.x-a.x)*(b.y-a.y);
D=-a.x*((b.y-a.y)*(c.z-a.z)-(c.y-a.y)*(b.z-a.z))
  -a.y*((b.z-a.z)*(c.x-a.x)-(c.z-a.z)*(b.x-a.x))
  -a.z*((b.x-a.x)*(c.y-a.y)-(c.x-a.x)*(b.y-a.y));
w=sqrt(A*A+B*B+C*C); if(w*w<1e-20) return 0; A/=w; B/=w; C/=w; D/=w;
s=(u.x-v.x)*A+(u.y-v.y)*B+(u.z-v.z)*C; if(s*s<1e-20) return 0;
s=(A*u.x+B*u.y+C*u.z+D)/s;
if(s<0?1:s>1) return 0; if(s<1e-4) s=0; if(s>1-1e-4) s=1; Q=u*(1-s)+v*s;
s=xyangle(Q,a,b)+xyangle(Q,b,c)+xyangle(Q,c,a); return s>.99*2*pi;}
/*-----*/// edge e of face F2 intersects face F1 at point p
int mesh::chained(Face*F1,Face*F2,xyz&p,int&e){int n1=F1->n,n2=F2->n,i,j;
fcinfo*I=F1->q,*J=F2->q; xyz K,L; if(!I?1:!J) return 0;
for(j=0;j<n2;j++) for(tt_[j]=0,K=J[j].p->a,i=0;i<n1;i++) if(K==I[i].p->a) {tt_[j]=1; break;}
for(j=0;j<n2;j++) if(intersection(F1,J[j].p,J[(j+1)%n2].p,p)) {e=j; return 1;}
return 0;}
/*-----*/
void mesh::duplinsc(Face*F,int c,int p){int i,j,n=F->n; if(c<0?1:c>=n?1:!F->q) return;
setnq_(nq+n+2); fcinfo*I=F->q,*Q=pts+nq; F->q=Q;
for(j=i=0;i<=c;i++) Q[j++]=I[i]; Q[j++]=I[c]; Q[j++]=I[c]; for(;i<n;i++) Q[j++]=I[i]; nq+=j;
F->n+=2; Q[c+1].p=point+p; if(Q[c].t) {setnt_(nt+1); t[nt]=*Q[c].t; Q[c+1].t=t+nt++;}}
/*-----*/
int mesh::sharedcorners(Face*F,Face*G,int(*t)[2]){int i,j,n=F->n,m=G->n,p=0; fcinfo*I=F->q,*J=G->q;
for(i=0;i<n;i++) for(j=0;j<m;j++) if(I[i].p==J[j].p) if(t) {t[p][0]=(I+i)-pts; t[p++][1]=(J+j)-pts;} else p++; return p;}
/*-----*/
void mesh::boolean(HWND wn){checkedges(); long K,N,nF; int i,j,k,l,m,ff,nP,Z[1024][2]; double w,pi=4*atan(1.);
char _[128]; Face *F,FF,*G,GG; fcinfo*I,*Y; xyz p1,p2; xyz Q,R[3]; altered=1;
LOOP: N=0; nF=nf; setnp_(np+nf+16); setnf_(nf+nq+16); setnq_(nq+6*nF+16);
for(K=0;K<nF;K++) if(G=fac+K,Y=G->q,Y) if(G->s) {
	 if(!G->q) continue; // loop G over all faces
	 /*if(!(K%100))*/ {sprintf(_,"main loop at %d of %d : %d welds",K,nF,N); SetTitle(wn,_);}
	 for(ff=0;ff<nF;ff++) if(F=&fac[ff],F->s) if(I=F->q,I) if(F->prt!=G->prt) { // loop F over all faces
		  k=sharedcorners(G,F,Z); m=G->n; // look for 2 faces in different surfaces sharing 2 nonadjacent corners
		  if(k>=2) for(i=1;i<k;i++) for(j=0;j<i;j++) {l=abs(Z[j][0]-Z[i][0]);
				if(l<2?0:l<m-1) {splitface(Z[i][0],Z[j][0]); N++; goto L1;}}
		  for(i=0;i<F->n;i++) {k=nf; nFW=1; FW[0]=Facen(ff,i); // look for an edge going through a face
				j=intersection(G,I[i].p,I[(i+1)%F->n].p,Q); if(!j) continue;
				nP=findaddpoint(Q); splitcurrentedge(nP,1,1); split(fac[K],point+nP); N++;
				for(ff=k;ff<nf;ff++) if(F=&fac[ff],F->s) if(I=F->q,I) if(F->n==3) { // 2 edges nearly crossed
					 w=fabs(xyangle(I[2].p->a,I[0].p->a,I[1].p->a))-pi;
					 if(w*w<1e-3) {nFW=1; FW[0]=Facen(F-fac,0); splitcurrentedge(nP,1,1); F->q=0; break;}}}
L1:;    }}
collectgarbage();
sprintf(_,"%d welds made in this iteration",N);
if(MessageBox(0,_,"shall I iterate again?",MB_YESNO)==IDYES) goto LOOP;
rerot=1; retit();}
/*-----*/
void mesh::special(){long i,j,k,l,m; fcinfo*I,*J,*V,*VL; Face*F,*FL; xyz P; xy R;// char L[64];
char*used=FM(char,np); xyz ll(llm.x,ulm.y,llm.z),ul(ulm.x,llm.y,ulm.z); altered=1;
for(i=0;i<np;i++) used[i]=point[i].h ?0: point[i].r.between(ll,ul);
Point***adjp=FM(Point**,np); for(k=i=0;i<np;i++) if(used[i]) k++;
Point**Adj=FM(Point*,k*32),**adj; xyz**oldpp=FM(xyz*,k),*newp=FM(xyz,k);
for(j=i=0;i<np;i++) if(used[i]) {oldpp[j]=&point[i].a; adjp[i]=&Adj[(j++)<<5];}
short*N=FM(short,k); for(i=0;i<k;i++) N[i]=0;
forallface() forvert() if(used[j=V->p-point]) {m=N[i=(((adj=adjp[j])-Adj)>>5)];
	 if(m>=32) continue; J=V==I?VL-1:V-1;
	 if(J->p->r.between(ll,ul)) for(l=0;l<m;l++) if(J->p==adj[l]) goto L1; adj[m++]=J->p; L1:
	 if(m>=32) continue; J=V+1==VL?I:V+1;
	 if(J->p->r.between(ll,ul)) for(l=0;l<m;l++) if(J->p==adj[l]) goto L2; adj[m++]=J->p; L2:
	 N[i]=(short)m;}
for(i=0;i<k;i++) if(N[i]) {adj=&Adj[i<<5];
	 for(P=xyz(0,0,0),j=N[i]-1;j>=0;j--) P=P+adj[j]->a; newp[i]=P*(1./N[i]);}
  else newp[i]=*oldpp[i];
for(i=0;i<k;i++) *oldpp[i]=newp[i];
FF(N); FF(oldpp); FF(newp); FF(used); FF(Adj); FF(adjp); rerot=1;}
/*--------------------*/
#define D3S_2sided                        0x0000a081
#define D3S_3deditor                      0x00003d3d
#define D3S_3dsversion                    0x00000002
#define D3S_color                         0x00000011
#define D3S_colorgamma                    0x00000012
#define D3S_faces                         0x00004120
#define D3S_facesmateriallist             0x00004130
#define D3S_facestexturemaplist           0x00004140
#define D3S_main                          0x00004d4d
#define D3S_materialambientcolor          0x0000a010
#define D3S_materialdiffusecolor          0x0000a020
#define D3S_materialeditor                0x0000afff
#define D3S_materialname                  0x0000a000
#define D3S_materialshininess             0x0000a040
#define D3S_materialshininessstrength     0x0000a041
#define D3S_materialspecularcolor         0x0000a030
#define D3S_meshversion                   0x00003d3e
#define D3S_objectblock                   0x00004000
#define D3S_percentfloat                  0x00000031
#define D3S_percentint                    0x00000030
#define D3S_positiontrack                 0x0000b020
#define D3S_reflectionblur                0x0000a053
#define D3S_rendertype                    0x0000a100
#define D3S_selfilluminate                0x0000a084
#define D3S_transparency                  0x0000a050
#define D3S_transparencyfalloff           0x0000a052
#define D3S_triangularmesh                0x00004100
#define D3S_vertexlist                    0x00004110
#define D3S_wirethickness                 0x0000a087
/*-----*/
class d3sbuf{public: char **B; long P; char*fn;
	 d3sbuf(char*file); ~d3sbuf(); void poke(int a,short v); void poke(int a,long v);
    void operator+=(char b);  void operator+=(byte b); void operator+=(char* b);
	 void operator+=(short b); void operator+=(long b); void operator+=(float b);
    void operator+=(xyz b);   void operator+=(int b);  void operator*=(COLORREF b);};
d3sbuf::d3sbuf(char*file){int i; P=0; fn=file; B=FM(char*,0x1000); for(i=0;i<4096;i++) B[i]=0;};
d3sbuf::~d3sbuf(){FILE*F=fopen(fn,"wb"); int i,n=P&0xfff,p=P>>12;
    for(i=0;i<p;i++) {fwrite(B[i],1,0x1000,F); FF(B[i]);} if(n) fwrite(B[p],1,n,F); FF(B);
    fclose(F);}
void d3sbuf::operator+=(char b){int i=P>>12,j=P&0xfff;
    if(!j) if(!B[i]) B[i]=FM(char,0x1000); B[i][j]=b; P++;}
inline void d3sbuf::operator+=(byte b){*this+=char(b);}
void d3sbuf::operator+=(char*s){do *this+=*s; while(*s++);}
void d3sbuf::operator+=(short s){*this+=(char)s; *this+=(char)(s>>8);}
inline void d3sbuf::operator+=(int s){*this+=(long)s;}
void d3sbuf::operator+=(long s){*this+=(char)s;
	 *this+=(char)(s>>8); *this+=(char)(s>>16); *this+=(char)(s>>24);}
void d3sbuf::operator*=(COLORREF s){*this+=(char)s; *this+=(char)(s>>8); *this+=(char)(s>>16);}
inline void d3sbuf::operator+=(float x){*(this)+=*(long*)&x;}
void d3sbuf::operator+=(xyz x){*(this)+=float(x.x); *(this)+=float(x.y); *(this)+=float(x.z);}
void d3sbuf::poke(int a,short v){int Q=P; P=a; *this+=v; P=Q;}
void d3sbuf::poke(int a,long  v){int Q=P; P=a; *this+=v; P=Q;}
/*-----*/
class chunk{public: int start,id; d3sbuf*object;
chunk(d3sbuf&obj,short ID); ~chunk();};
chunk::chunk(d3sbuf&obj,short ID){object=&obj; start=obj.P; obj+=ID; obj.P+=4;};
chunk::~chunk(){object->poke(start+2,(long)(object->P-start));};
/*-----*/
void facet(d3sbuf&D,short A,short B,short C){D+=A; D+=B; D+=C; D+=short(7);}
void color(d3sbuf&D,COLORREF c){chunk _(D,D3S_color); D*=c;}
void colorgamma(d3sbuf&D,COLORREF g){chunk _(D,D3S_colorgamma); D*=g;}
void colors(d3sbuf&D,COLORREF c,COLORREF g){color(D,c); colorgamma(D,g);}
void percent(d3sbuf&D,int p){chunk _(D,D3S_percentint); D+=short(p);}
void percent(d3sbuf&D,double p){chunk _(D,D3S_percentfloat); D+=float(p);}
/*---------------------*/
char*selonly="Do you want me to output only the selected parts?",printedall;
/*-----*/
int mesh::readDXF(char*file,int append) {Point*PP[4]; long e=0,i,k,I=0,n=0,P[4],NF,NQ,NP;
double x; char c[256],d[256],N[256],T[1024]; xyz A,B,C,D,o(0,0,0); FILE*H;
if(!append) initialize(1); GetTitle(Wn,T,128); *N=0;
H=fopen(file,"r"); if(!H) {MessageBox(0,file,"I can't open this file",OUCH); return 0;}
NF=nf; NQ=nq; NP=np;
while(fgets(c,256,H)) if(!strncmp(c,"3DFACE",6)) n++; rewind(H); NF+=n; NQ+=4*n; NP+=4*n;
if(!setnf_(NF) ?1: !setnq_(NQ) ?1: !setnp_(NP)) return 0;
FACE: if(!fgets(c,256,H)) goto WHOA; if(!fgets(d,256,H)) goto WHOA;
i=strlen(d); if(i) if(d[--i]=='\n') d[i]=0;
if(!strcmp(d,"EOF")) e=1; else if(!strcmp(d,"ENDSEC")) e=1;
else {x=k=0; sscanf(c,"%ld",&k); sscanf(d,"%le",&x);}
if(e?1:!strncmp(d,"3DFACE",6)) {
    if(I) {
        P[0]=findaddpoint(A); P[1]=findaddpoint(B); P[2]=findaddpoint(C); P[3]=findaddpoint(D);
        for(i=0;i<4;i++) PP[i]=&point[P[i]];
        if(P[0]!=P[2]) if(P[1]!=P[3]) {
				addface(PP,4,1); fac[nf-1].mat=(short)(findaddmat(0x00808080,*N?N:"defaultmat")); *N=0;}
        if(!(I&0xff)) {sprintf(c,"%5ld",I); SetTitle(Wn,c);}}
    I++; A=o; B=o; C=o; D=o; if(e) goto WHOA; goto FACE;}
switch(k) {case 8: if(isalpha(*d)) strcpy(N,d); else sprintf(N,"material%s",d); break;
    case 10: A.x=x; break; case 20: A.y=x; break; case 30: A.z=x; break;
    case 11: B.x=x; break; case 21: B.y=x; break; case 31: B.z=x; break;
	 case 12: C.x=x; break; case 22: C.y=x; break; case 32: C.z=x; break;
    case 13: D.x=x; break; case 23: D.y=x; break; case 33: D.z=x; break;}
goto FACE;
WHOA: fclose(H); if(!I) {MessageBox(0,file,"bad DXF file",OUCH); return 0;}
ntitap=1; SetTitle(Wn,T); sel1point(0);
//setnf_(nf,1); setnq_(nq,1); setnp_(np,1); setnt_(nt,1);
collectgarbage(); return I;}
/*----*/
void DXFface(FILE*H,xyz a,xyz b,xyz c,xyz d){fprintf(H,
"0\n3DFACE\n8\n0\n10\n%5.3f\n20\n%5.3f\n30\n%5.3f\n11\n%5.3f\n21\n%5.3f\n31\n\
%5.3f\n12\n%5.3f\n22\n%5.3f\n32\n%5.3f\n13\n%5.3f\n23\n%5.3f\n33\n%5.3f\n",
  a.x,a.y,a.z,b.x,b.y,b.z,c.x,c.y,c.z,d.x,d.y,d.z);}
/*-----*/
int mesh::writeDXF(char*file){char*s;
FILE*H=fopen(file,"w"); if(!H) return 0; long i,k,n; fcinfo*I; Face*F,*FL;
fprintf(H,"0\nSECTION\n2\nENTITIES\n"); /**** what if face has !=4 edges? ****/
for(k=i=0;i<nf;i++) if(!fac[i].s) {k=1; break;}
if(k) if(MessageBox(0,selonly,"",4)!=6) k=0; printedall=!k;
forallface() if(k?F->s:1) {n=F->n;
    for(k=1;k<n-2;k+=2) DXFface(H,I[0].p->a,I[k].p->a,I[k+1].p->a,I[k+2].p->a);
    if(n&1) DXFface(H,I[0].p->a,I[n-2].p->a,I[n-1].p->a,I[n-1].p->a);
    if(F->mat) fprintf(H,"8\n%s\n",(s=mat[F->mat].name,s?s:"THE VOID"));}
fprintf(H,"0\nENDSEC\n0\nEOF\n"); fclose(H); return 1;}
/*-----*/
long lfread(void*q,int leng,long n,FILE*F){n*=leng; long i,j=0,k,N=n>>14; char*p=(char*)q;
for(i=0;i<N;i++) {k=fread(p+(i<<14),1,0x4000,F); if(k<=0) goto EOFF; j+=k;}
k=fread(p+(N<<14),1,n&0x3fff,F); if(k>0) j+=k;
EOFF: fclose(F); return j/leng;}
/*-----*/
class chunkhdr{public: uns short I; long N;}; chunkhdr d3sbeg; char*d3sbf=0,*d3send; long chP;
/*-----*/
static int _3DSfacestart;
/*-----*/
char*mesh::readchunk(int deep){long i,j,k,n,end,NN=d3sbeg.N-chP,M; char*ch=d3sbf+chP;
float*X; short*Y; char*s; chunkhdr H=*(chunkhdr*)ch; end=chP+H.N; Point*PP[3];
if(NN<6) return "chunk too short";
if(H.N>NN) return "chunk runs off end";
//{FILE*F=fopen("c:\\3d\\makeobj\\____.cpp","a"); int i; for(i=0;i<deep;i++) fprintf(F,"  ");
//	 fprintf(F,"chunk 0x%04x\n",H.I&0xffff); fclose(F);}
switch(H.I&0xffff){default: DEF: chP+=H.N; return 0;
REC: chP+=6; while(chP<end) if(s=readchunk(deep+1),s) return s; return 0;
case D3S_main: goto REC;
case D3S_3deditor: goto REC;
case D3S_materialeditor: i=chP; j=chP+H.N; chP+=6; M=addmat(0,0);
	 while(chP<j) if(s=read3DSmaterialeditor(M),s) return s; chP=i; goto DEF;
/****** I must cater for > 1 object block in the same 3DS file ******/
case D3S_objectblock: currentgroup=short(addgroup(ch+6)); chP+=6+strlen(ch+6)+1-6; /*skip object name*/
	 chP+=6; po=np; while(chP<end) if(s=readchunk(deep+1),s) return s; return 0;
case D3S_triangularmesh: goto REC;
case D3S_vertexlist: n=*(short*)(ch+6); if(8+n*12>NN) return "bad vertex list";
	 X=(float*)(ch+8); for(j=i=0;i<n;i++,j+=3) addpoint(xyz(X[j],X[j+1],X[j+2])); goto DEF;
case D3S_faces: n=*(short*)(ch+6); _3DSfacestart=nf;
	 if(8+n*8>NN) return "bad face list"; Y=(short*)(ch+8);
	 for(i=0;i<4*n;i++) if((i+1)&3) if(Y[i]>=np) return "bad vertex number";
	 for(j=i=0;i<n;i++) {
		  PP[0]=point+Y[j++]+po; PP[1]=point+Y[j++]+po; PP[2]=point+Y[j++]+po; j++; addface(PP,3);}
	 chP+=8+8*n; scaled=0; while(chP<end) if(s=readchunk(deep+1),s) return s; return 0;
case D3S_facesmateriallist:
	 for(i=0;i<nmat;i++) if(!lstrcmp(ch+6,mat[i].name)) break;
///MessageBox(0,ch+6,"I found a facesmateriallist for material",OUCH);
	 if(i>=nmat) goto DEF; ch+=strlen(ch+6)+1+6; k=*(short*)ch; ch+=2;
		 while(ch<d3send) {j=_3DSfacestart+*(short*)ch; ch+=2; if(j>=0) if(j<nf) fac[j].mat=short(i);
			  if(--k<=0) break;}
		 goto DEF;
#if 0
case D3S_facestexturemaplist: {ch+=6; k=*(short*)ch; ch+=2; int tp=nt; setnt_(nt+k);
//       char L[32]; sprintf(L,"sizeof(float)=%d",sizeof(float)); MessageBox(0,L,"",OUCH);
		 while(ch<=d3send-8) {addt(xy(*(float*)ch,*(float*)(ch+4))); ch+=8; if(--k<=0) break;}
		 i=max(0,fac[_3DSfacestart].q-pts);
		 for(j=i;j<nq;j++) pts[j].t=t+(pts[j].p-point)-tp+i;
		 goto DEF;}
#endif
}}
/*-----*/
char*mesh::read3DSmaterialeditor(long MM,int deep){
//{FILE*F=fopen("c:\\3d\\makeobj\\____.cpp","a"); fprintf(F,"entered read3DSmaterialeditor\n"); fclose(F);}
long end,NN=d3sbeg.N-chP,M=MM&0xffff,Mc=(MM>>16)&0xffff;
char*ch=d3sbf+chP; char*s; chunkhdr H=*(chunkhdr*)ch; end=chP+(H.N&0x0000ffff);
if(NN<6) return "chunk too short";
if(H.N>NN) return "chunk runs off end";
//{FILE*F=fopen("c:\\3d\\makeobj\\____.cpp","a"); int i; for(i=0;i<deep;i++) fprintf(F,"  ");
//	 fprintf(F,"chunk 0x%04x\n",H.I&0xffff); fclose(F);}
switch(H.I&0xffff){default: DEF: chP+=H.N; return 0;
REC: chP+=6; while(chP<end) {if(s=read3DSmaterialeditor(M+(H.I<<16),deep+1),s) return s;}
	 return 0;
case D3S_materialname: mat[M].rename(ch+6); goto DEF;
case D3S_color: if(Mc==D3S_materialdiffusecolor) mat[M].df=(*(long*)(ch+6))&0x00ffffff; goto DEF;
case D3S_materialdiffusecolor: goto REC;}}
/*-----*/
int mesh::read3DS(char*file,int append){FILE*F=fopen(file,"rb"); long I,N,i; char*s;
if(!append) initialize(1); if(!F) {MessageBox(0,file,"I can't open this file",OUCH); return 0;}
i=fread(&d3sbeg,1,6,F); fclose(F);
if(i<6) {BAD: MessageBox(0,file,"bad 3DS file",OUCH);
    Z: if(d3sbf) FF(d3sbf); d3sbf=0; po=append?np:0; return 0;}
I=d3sbeg.I; N=d3sbeg.N; if(I!=0x4d4d ?1: N<6 ?1: N>5e6) goto BAD;
d3sbf=FM(char,N); if(!d3sbf) {MessageBox(0,file,"file too big",OUCH); return 0;}
d3send=d3sbf+N;
F=fopen(file,"rb"); i=lfread(d3sbf,1,N,F); fclose(F); if(i<N) goto BAD; chP=0;
if(s=readchunk(),s) {MessageBox(0,s,file,OUCH); goto Z;}
FF(d3sbf); d3sbf=0; po=0; sel1point(0); return 1;}
/*-----*/
int mesh::write3DS(char*file){long i,j,J,k,kk,l,n,N,R,t; d3sbuf M(file);
fcinfo*I,*V,*VL; Face*F,*FL; collectgarbage();
for(kk=i=0;i<nf;i++) if(!fac[i].s) {kk=1; break;}
if(kk) if(MessageBox(0,selonly,"",4)!=6) kk=0;  printedall=!kk;
{chunk _(M,D3S_main);
    {chunk _(M,D3S_3dsversion); M+=long(3);}
    {chunk _(M,D3S_3deditor);
        {chunk _(M,D3S_meshversion); M+=long(3);}
        for(j=0;j<nmat;j++) {chunk _(M,(short)D3S_materialeditor);
//          COLORREF col=RGB(((j&1)?255:0),byte((j&2)?255:0),byte((j&4)?255:0));
            {chunk _(M,(short)D3S_materialname); M+=mat[j].name;}
//            {chunk _(M,D3S_materialambientcolor); colors(M,white,white);}
            {chunk _(M,(short)D3S_materialdiffusecolor); colors(M,mat[j].df,mat[j].df);}
//            {chunk _(M,D3S_materialdiffusecolor); colors(M,0x00ff00ff,0x00ff00ff);}
//            {chunk _(M,D3S_materialdiffusecolor); colors(M,white,white);}
//            {chunk _(M,D3S_materialspecularcolor); colors(M,white,white);}
//            {chunk _(M,D3S_materialshininess); percent(M,0);}
//            {chunk _(M,D3S_materialshininessstrength); percent(M,0);}
//            {chunk _(M,D3S_transparency); percent(M,0);}
//            {chunk _(M,D3S_transparencyfalloff); percent(M,0);}
//            {chunk _(M,D3S_selfilluminate); percent(M,0);}
//            {chunk _(M,D3S_reflectionblur); percent(M,0);}
//            {chunk _(M,D3S_rendertype); M+=short(1);}
            }
        for(k=0;k<ng;k++) {
            char*U=FM(char,np); long*T=FM(long,np); memset(U,0,np);
            forface() if(F->g==k) forvert() U[V->p-point]=1;
            for(N=i=0;i<np;i++) if(U[i]) T[i]=N++;
            if(N) {chunk _(M,D3S_objectblock); M+=group[k].name; uns short*Mat;
                {chunk _(M,D3S_triangularmesh);
                    {chunk _(M,D3S_vertexlist); R=M.P; M+=short(0);
                        for(l=J=0;J<np;J++) if(U[J]) {l++; M+=point[J].a;} M.poke(R,short(l));}
                    {chunk _(M,D3S_faces); R=M.P; M+=short(0); /* break up polygons into triangles */
                        t=0; forallface() if(kk?F->s:1) if(F->g==k) {n=F->n; t+=max(1,n-2);}
                        Mat=FM(uns short,t);
                        N=0; forallface() if(kk?F->s:1) if(F->g==k) for(n=F->n,l=1;l<n-1;l++) {
                            facet(M,short(T[I[0].p-point]),short(T[I[l].p-point]),short(T[I[l+1].p-point]));
                            Mat[N++]=F->mat;}
                        M.poke(R,short(N));}
                    for(j=0;j<nmat;j++) {
                        for(l=i=0;i<N;i++) if(Mat[i]==j) l++;
                        {chunk _(M,D3S_facesmateriallist);
                            M+=mat[j].name; M+=short(l);
                            for(i=0;i<N;i++) if(Mat[i]==j) M+=short(i);}}}
					 FF(Mat);}
            FF(U); FF(T);}}}
return 1;}
/*-----*/
int countOBJ(char*file,long&NF,long&NQ,long&NP,long&NT,long&ND,long&NG,long&NMAT){
FILE*G=fopen(file,"rb"); long i,j,M,N; char L[128],*P[128],Eof;
if(!G) {MessageBox(0,file,"I can't open this file",OUCH); return 0;}
LOOP: for(i=0;i<127;i++) {j=L[i]=fgetc(G); Eof=feof(G); if(Eof?1:j==10?1:j==13) break;}
N=i; L[i]=0; if(Eof) goto END; for(i=0;i<N;i++) if(L[i]<0?0:L[i]<=32) L[i]=0;
while(!N?0:!L[N-1]) N--; if(!N) goto LOOP; if(L[0]) {M=1; P[0]=L;} else M=0;
for(i=1;i<N;i++) if(L[i]) if(!L[i-1]) P[M++]=&L[i]; if(M<2) goto LOOP; /* find components */
if(!_stricmp(P[0],"v")) {/* vertex */ NP++; goto LOOP;}
if(!_stricmp(P[0],"vt")) {NT++; goto LOOP;} /*texture*/
if(!_stricmp(P[0],"vn")) {/* normal */ ND++; goto LOOP;}
if(!_stricmp(P[0],"f")) {NF++; NQ+=M; /* face */ goto LOOP;}
if(!_stricmp(P[0],"g")) {NG++; goto LOOP;}
//if(!stricmp(P[0],"actor")) {NG++; goto LOOP;}
if(!_stricmp(P[0],"usemtl")) NMAT++; goto LOOP;
END: fclose(G); return 1;}
/*-----*/
int mesh::readOBJ(char*file,int append){long i,j,M,N,v,T,D,C=0,NF,NQ,NP,NT,ND,NG,NMAT;
double x,y,z,LL; char a,L[1024],*P[1024],*V,Eof=0,Z[32],*bad; Face*F; fcinfo*I;
if(!append) initialize(1);
{TempTitle M(Wn,"I am counting the vertexes etc in the file");
	 NF=nf; NQ=nq; NP=np; NT=nt; ND=nd; NG=ng; NMAT=nmat; countOBJ(file,NF,NQ,NP,NT,ND,NG,NMAT);}
FILE*G=fopen(file,"rb"); if(!G) {MessageBox(0,file,"I can't open this file",OUCH); return 0;}
long dnt=append?nt:0,dnd=append?nd:0,dnp=append?np:0;
if(!setnf_(NF) ?1: !setnq_(NQ) ?1: !setnp_(NP) ?1: !setnt_(NT) ?1: !setnd_(ND) ?1: !setng_(NG)
  ?1: !setnmat_(NMAT)) return 0;
LOOP: for(i=0;i<1023;i++) {j=L[i]=fgetc(G); Eof=Eof?1:feof(G); if(Eof?1:j==10?1:j==13) break;}
N=i; L[i]=0; LL=i;
if(Eof) goto END; for(i=0;i<N;i++) if(L[i]<0?0:L[i]<=32) L[i]=0;
while(!N?0:!L[N-1]) N--; if(!N) goto LOOP; C++;
if(L[0]) {M=1; P[0]=L;} else M=0;
for(i=1;i<N;i++) if(L[i]) if(!L[i-1]) P[M++]=&L[i]; if(M<2) goto LOOP; M--; /* find components */
if(!_stricmp(P[0],"v")) {bad="<3 args"; if(M<3) goto BAD; /* vertex */
	 x=atof(P[1]); y=atof(P[2]); z=atof(P[3]); addpoint(xyz(x,y,z)); goto LOOP;}
if(!_stricmp(P[0],"vt")) {bad="<2 args"; if(M<2) goto BAD; x=atof(P[1]); y=M<2?0:atof(P[2]);
	 if(fabs(x)>1e5) x=0; if(fabs(y)>1e5) y=0; addt(xy(x,y)); goto LOOP;} /*texture*/
if(!_stricmp(P[0],"vn")) {bad="<3 args"; if(M<3) goto BAD; /* normal */
	 x=atof(P[1]); y=atof(P[2]); z=atof(P[3]); addd(xyz(x,y,z)); goto LOOP;}
if(!_stricmp(P[0],"f")?1:!_stricmp(P[0],"fo")) {F=addface(M); /* face */
	 if(F) for(I=F->q,i=1;i<=M;i++) {T=D=0; V=P[i]; sscanf(V,"%ld",&v);
		  for(j=0;a=V[j],a;j++) if(a=='/') break; if(a) if(!sscanf(V+=j+1,"%ld",&T)) T=0;
		  for(j=0;a=V[j],a;j++) if(a=='/') break; if(a) if(!sscanf(V+=j+1,"%ld",&D)) D=0;
		  if(v<0) v+=np+1; else v+=dnp; bad="no such vertex";  if(v<1?1:v>np) goto BAD;
		  if(T<0) T+=nt+1; else T+=dnt; if(T<0?1:T>nt) T=1;
		  if(D<0) D+=nd+1; else D+=dnd; bad="no such normal"; if(D<0?1:D>nd) goto BAD;
		  I[i-1].p=&point[v-1]; I[i-1].t=T?&t[T-1]:0; I[i-1].d=D?&d[D-1]:0;}
	 goto LOOP;}
if(!_stricmp(P[0],"mtllib")) {if(!mtllib) {for(i=P[1]-L;i<LL;i++) if(!L[i]) L[i]=' ';
	 i=strlen(P[1]); strcpy(mtllib=FM(char,i+1),P[1]);}} else
if(!_stricmp(P[0],"g")) {for(i=P[1]-L;i<LL;i++) if(!L[i]) L[i]=' ';
	 currentgroup=short(findaddgroup(P[1]));} else
if(!_stricmp(P[0],"actor")) {for(i=P[1]-L;i<LL;i++) if(!L[i]) L[i]=' ';
	 j=strlen(P[1]); for(i=0;i<j;i++) if(P[1][i]==':') break; P[1][i]=0;
	 currentgroup=short(findaddgroup(P[1])); dnt=nt; dnd=nd; dnp=np;} else
if(!_stricmp(P[0],"prop")) {for(i=P[1]-L;i<LL;i++) if(!L[i]) L[i]=' ';
	 char L[1024]; strcpy(L,"prop___"); strncpy(L+7,P[1],1024-7); L[1023]=0;
	 j=strlen(L); for(i=0;i<j;i++) if(L[i]==':') break; L[i]=0;
	 currentgroup=short(findaddgroup(L)); dnt=nt; dnd=nd; dnp=np;} else
if(!_stricmp(P[0],"geomCustom")) {dnt=nt; dnd=nd; dnp=np;} else
if(!_stricmp(P[0],"usemtl")) {for(i=P[1]-L;i<LL;i++) if(!L[i]) L[i]=' ';
	 currentmat=short(findaddmat(0,P[1]));} goto LOOP;
END: sel1point(0); fclose(G); i=1; goto EXIT;
BAD: fclose(G); sprintf(Z,"line %d is bad: %s",C,bad); for(i=0;i<N;i++) if(!L[i]) L[i]=' ';
MessageBox(0,L,Z/*file*/,OUCH); i=0;
EXIT:
setnf_(nf,1); setnq_(nq,1); setnp_(np,1); setnt_(nt,1); setnd_(nd,1); setng_(ng,1);
setnmat_(nmat,1); setntma_(ntma,1); setnprt_(nprt,1); return i;}
/*-----*/
#define fflush(H)
int mesh::writeOBJ(char*fn,int special){int Np=0,Nt=0,Nd=0; xyz u;
if(special&1) {Np=np+1; Nt=nt+1; Nd=nd+1;} /* in v lines, all v vn vt numbers to be relative */
FILE*H=fopen(fn,"w"); if(!H) {MessageBox(0,fn,"can't open file",OUCH); return 0;}
long g,i,j,k,l,kk,m,maxn; Face*F,*FL; fcinfo*I;
for(k=i=0;i<nf;i++) if(fac[i].q) if(!fac[i].s) {k=1; break;}
if(k) if(MessageBox(0,selonly,"",4)!=6) k=0; kk=k; printedall=!k;
maxn=0; forallface() if(k?F->s:1) if(F->n<maxn) maxn=F->n;
fprintf(H,"# File generated by MAKEOBJ\n"); fflush(H);
fprintf(H,"# NumFacets/MaxNumEdges   %d/%d\n",nf,maxn); fflush(H);
fprintf(H,"# NumVerts/NumTVerts/NumVNormals   %d/%d/%d\n",np,nt,nd); fflush(H);
if(mtllib) fprintf(H,"mtllib %s\n",mtllib);
for(i=0;i<np;i++) {u=point[i].a; fprintf(H,"v %6g %6g %6g\n",u.x,u.y,u.z); fflush(H);}
for(i=0;i<nt;i++) {fprintf(H,"vt %6g %6g\n",t[i].a.x,t[i].a.y); fflush(H);}
for(i=0;i<nd;i++) {fprintf(H,"vn %6g %6g %6g\n",d[i].x,d[i].y,d[i].z); fflush(H);}
for(k=0;k<ng;k++) {g=1;
	for(l=0;l<nmat;l++) {m=1;
		forallface() if(kk?F->s:1) if(F->g==k) if(F->mat==l) {
			if(g) {fprintf(H,"g %s\n",group[k].name); fflush(H); g=0;}
			if(m) {fprintf(H,"usemtl %s\n",mat[F->mat].name); fflush(H); m=0;}
			fputc('f',H);//   fprintf(H,"f");
			for(j=0;j<F->n;j++) {Point*P=I[j].p; Texp*T=I[j].t; xyz*D=I[j].d;
				fprintf(H," %ld",long(P-point)+1-Np);
				if(!D) {if(T) fprintf(H,"/%ld",long(T-t)+1-Nt);}
				else {if(!T) fprintf(H,"//%ld",long(D-d)+1-Nd);
					else fprintf(H,"/%ld/%ld",long(T-t)+1-Nt,long(D-d)+1-Nd);}}
			fprintf(H,"\n"); fflush(H);
			if(special&2) {fprintf(H," ##");
				for(j=0;j<F->n;j++) {u=I[j].p->a; fprintf(H," / %g,%g,%g",u.x,u.y,u.z);}}
			/*fscanf(H,"\n",1);* fflush(H);*/}}}
fclose(H); return 1;}
/*-----*/
short clipboardimageread(image&I,HDC dc,HWND wn){//temphdr H("reading from clipboard",wn);
short i; if(!OpenClipboard(wn)) {MessageBox(0,"I can't open the clipboard","",OUCH); return 0;}
HANDLE ch=GetClipboardData(CF_BITMAP);
if(!ch) {CloseClipboard(); MessageBox(0,"There is no BITMAP in the clipboard","",OUCH); return 0;}
HBITMAP b=(HBITMAP)ch; BITMAP bm; image J; J.P=0; GetObject(b,sizeof(BITMAP),&bm);
i=bm.bmPlanes*bm.bmBitsPixel;
char S[64]; sprintf(S,"%d planes, bpp=%d",bm.bmPlanes,bm.bmBitsPixel);
if(i==16) i=24;
//char SS[64]; sprintf(SS,"Y=%d,i=%d",bm.bmHeight,i); MessageBox(0,"4",SS,OUCH);
if(!J.reset(bm.bmWidth,bm.bmHeight,i,i)) {MessageBox(wn,"out of store","reading clipboard",OUCH); return 0;}
GetDIBits(dc,b,0,bm.bmHeight,J.P,(BITMAPINFO*)&J.size,DIB_RGB_COLORS);
MessageBox(wn,S,"reading clipboard",MB_OK);
//MessageBox(0,J.P?"J.P!=0":"J.P==0","",OUCH);
char L[32]; sprintf(L,"read image, bpp =%d",i); MessageBox(0,L,"",OUCH);
switch(i){case 8: case 24: I<<J; break;
case 32: imageconv(I,J,24); I.rbpp=24; /*FF(J.P);*/ J.P=0; break; //////////// this FF causes fault "you tried to delete memory mnot allocated"
case 16: imageconv(I,J,24); I.rbpp=16; FF(J.P); J.P=0; break;
case 1: case 4: imageconv(I,J,8); I.rbpp=i; FF(J.P); J.P=0;}
CloseClipboard();
J.P=0; return 1;}
/*-----*/
#if 0
short clipboardimageread(image&I,HDC dc,HWND wn) {
short i; if(!OpenClipboard(wn)) return 0;
HANDLE ch=GetClipboardData(CF_DIB); if(!ch) {CloseClipboard(); return 0;}
HBITMAP b=(HBITMAP)ch; BITMAPINFO bm; image J; GetObject(b,40,&J.size);
//i=bm.bmPlanes*bm.bmBitsPixel;
i=J.planes*J.bpp;
char S[64]; sprintf(S,"%d planes, bpp=%d",J.planes,J.bpp);
sprintf(S,"image on clipboard is %d x %d",J.X,J.Y); MessageBox(0,S,"",OUCH);
if(i==16) i=24;
if(!J.reset(J.X,J.Y,i,i)) {MessageBox(wn,"out of store","reading clipboard",OUCH); return 0;}
GetDIBits(dc,b,0,J.X,J.P,(BITMAPINFO*)&J.size,DIB_RGB_COLORS);
MessageBox(wn,S,"reading image from clipboard",MB_OK);
switch(i){case 8: case 24: I<<J; break;
case 16: imageconv(I,J,24); I.rbpp=16; FF(J.P); break;
case 1: case 4: imageconv(I,J,8); I.rbpp=i; FF(J.P);}
CloseClipboard(); J.P=0; return 1;}
#endif
/*--------------------*/
void readfromclipboard(HWND wn,image*&I){HDC dc=GetDC(wn);
if(!I) {I=FM(image,1); I->P=0; I->reset(16,16,24,24);}
int i=clipboardimageread(*I,dc,wn); if(!i) MessageBox(wn,"no image found in clipboard","",OUCH);
if(I->bpp!=24) {MessageBox(0,"image must be truecolor","",OUCH); if(I->P) FF(I->P); FF(I); I=0;} ReleaseDC(wn,dc);}
/*-----*/
void image_reset(image*&I,int x,int y){if(!I) I=new image(x,y,24); else I->reset(x,y,24,24);}
/*-----*/
