#ifndef XYDECL
#define XYDECL 1
#include <math.h>
inline double sqd(double x){return x*x;}
class xy{public: double x,y;
inline xy(){x=y=0;};
inline xy(double X,double Y){x=X; y=Y;};
inline void operator+=(const xy z){x+=z.x; y+=z.y;};
inline void operator-=(const xy z){x-=z.x; y-=z.y;};
inline int operator==(const xy z){return x!=z.x?0:y==z.y;};
inline xy operator+(const xy z){return xy(x+z.x,y+z.y);};
inline xy operator-(const xy z){return xy(x-z.x,y-z.y);};
inline xy operator&(const xy z){return xy(x*z.x,y*z.y);};
inline xy operator%(const xy z){return z.x*z.y?xy(x/z.x,y/z.y):*this;};
inline xy operator*(const xy z){return xy(x*z.x-y*z.y, x*z.y+y*z.x);};
inline xy operator|(const xy z){return xy(x*z.x+y*z.y,-x*z.y+y*z.x);};
inline void operator*=(const xy z){double w=x*z.x-y*z.y; y=x*z.y+y*z.x; x=w;};
inline xy operator*(double z){return xy(x*z, y*z);};
inline xy operator/(double z){return xy(x/z, y/z);};
inline void operator*=(double z){x*=z; y*=z;};
inline void operator/=(double z){x/=z; y/=z;};
inline xy operator-(){return xy(-x,-y);};
inline double operator^(const xy&z){return sqd(x-z.x)*sqd(y-z.y);};
inline xy operator--(){return xy(x,-y);};
inline double rr(){return x*x+y*y;};
inline double r(){return sqrt(x*x+y*y);};
inline xy operator|(long r){return xy(r?-x:x,y);};
inline xy operator^(long r){return xy(x,r?-y:y);};
inline double atan2(){return (x?1:y)?::atan2(y,x):0;};
inline xy rot1(xy&pivot,xy&theta){return pivot+(*this-pivot)*theta;};
};
inline xy cis(double th){return xy(cos(th),sin(th));};
extern double atan(xy&z);
extern xy norm(xy z);
/*-----*/
class ij{public: long x,y; /* fixed-point real with the point in the middle */
inline ij(){};
inline ij(long i,long j){x=i; y=j;};
inline ij(const xy&z){x=long(z.x*(256L*256)); y=long(z.y*(256L*256));};
inline void operator+=(const ij&z){x+=z.x; y+=z.y;};
inline void operator-=(const ij&z){x-=z.x; y-=z.y;};
inline ij operator+(const ij&z){ij w(x+z.x,y+z.y); return w;};
inline ij operator-(const ij&z){ij w(x-z.x,y-z.y); return w;};
inline ij operator*(double z){ij w(long(x*z), long(y*z)); return w;};
inline ij operator*(int    z){ij w(x*z,y*z); return w;};
inline ij operator*(long   z){ij w(x*z,y*z); return w;};};
/*-----*/
class bit{public: char*addr; int i;
bit(char*a,int j){addr=a; i=j;};
void set(){addr[i>>3]|=(char) (128>>(i&7));};
void clr(){addr[i>>3]&=(char)~(128>>(i&7));};
void chg(){addr[i>>3]^=(char) (128>>(i&7));};
operator int(){return addr[i>>3]&(char)(128>>(i&7));};};
/*-----*/
class bits{public: char*addr;
bits(char*Addr){addr=Addr;};
bit operator[](int i){return bit(addr,i);};};
/*-----*/
//class Menu{public: HMENU h;
//Menu(){};
//Menu(HWND wn){h=GetMenu(wn);};
//Menu operator[](int i){Menu m; m.h=GetSubMenu(h,i); return m;};
//};
#endif
