#include "stdafx.h"
#include <fcntl.h>
//#include <mem.h>
#include <new.h>
#include <math.h>
#include <setjmp.h>
#include <string.h>
#include <sys/stat.h>
#include <time.h>
#include "defines.h"
#include "xy.h"
#include "xyz.h"
#include "images.h"
#include "mesh.h"
#include "makemesh.h"
double deg,pi; short currentmat=0;
/*-----*/
void set(xyz*P,double*X,int n){int i,j=0; for(i=0;i<n;i++) {P[i].x=X[j++]; P[i].y=X[j++]; P[i].z=X[j++];}}
/*-----*/
makemesh::makemesh(mesh&M){OB=&M; /*OB->delarrays(); OB->initialize();*/}
makemesh::~makemesh(){}
/*-----*/
Face*makemesh::face(xyz p0,xyz p1,xyz p2,xyz p3){Point*p[4]; long a,b,c,d;
a=OB->findaddpoint(p0);
b=OB->findaddpoint(p1);
c=OB->findaddpoint(p2);
d=OB->findaddpoint(p3);
p[0]=OB->point+a; p[1]=OB->point+b; p[2]=OB->point+c; p[3]=OB->point+d;
return OB->addface(p,4);}
/*-----*/
Face*makemesh::face(xyz p0,xyz p1,xyz p2){return face(p0,p1,p2,p2);};
/*-----*/
void makemesh::face(xyz*P,int N){int i; if(N==4) face(P[0],P[1],P[2],P[3]); else
	 for(i=2;i<N;i++) face(P[0],P[i-1],P[i]);};
/*-----*/
void makemesh::seg(xyz*X,xyz*Y,int M){int i,N=abs(M);
if(M>0) face(X[0],X[N-1],Y[N-1],Y[0]);
for(i=1;i<N;i++) face(X[i],X[i-1],Y[i-1],Y[i]);}
/*-----*/
#define rot(x,y,ct,st) (w=x*ct-y*(st), y=x*(st)+y*ct, x=w)
/*inline double sq(double x){return x*x;} */
/*----- of N points, in xyz[0:N-1], radius r, centre at C, axis parallel to DE */
void circle3d(xyz*X,xyz C,xyz D,xyz E,double r,int N){
xyz A=D-E; int i; double pi=4*atan(1.),w,ct,st;
w=A.r(); w=w?w:1; ct=sqrt(A.x*A.x+A.y*A.y)/w; st=A.z/w;
for(i=0;i<N;i++) {w=i*2*pi/N; X[i]=xyz(st*cos(w),sin(w),-ct*cos(w));}
w=sqrt(A.x*A.x+A.y*A.y); if(w) {ct=A.x/w; st=A.y/w;} else {ct=1; st=0;}
for(i=0;i<N;i++) {rot(X[i].x,X[i].y,ct,st); X[i]=X[i]*r+C;}}
/*-----*/
void sort2(double&x,double&y){double z; if(x>y) {z=y; y=x; x=z;}}
/*-----*/
void makemesh::block(double x,double X,double y,double Y,double z,double Z){
char i=x!=X, j=y!=Y, k=z!=Z; sort2(x,X); sort2(y,Y); sort2(z,Z);
		if(j) if(k) face(xyz(x,y,z),xyz(x,y,Z),xyz(x,Y,Z),xyz(x,Y,z));
if(i) if(j)       face(xyz(x,y,z),xyz(x,Y,z),xyz(X,Y,z),xyz(X,y,z));
if(i)       if(k) face(xyz(x,y,z),xyz(X,y,z),xyz(X,y,Z),xyz(x,y,Z));
if(i)	if(j) if(k) {face(xyz(X,y,z),xyz(X,Y,z),xyz(X,Y,Z),xyz(X,y,Z));
						 face(xyz(x,y,Z),xyz(X,y,Z),xyz(X,Y,Z),xyz(x,Y,Z));
						 face(xyz(x,Y,z),xyz(x,Y,Z),xyz(X,Y,Z),xyz(X,Y,z));}}
/*-----*/
 void makemesh::sphere(xyz c,double R,int N){if(!N) return;
int i,n=N/2,m=n/2; deg=atan(1.)/45; double a,x,r,pi=180*deg; xyz*P=FM(xyz,N*(n+1));
for(i=0;i<=n;i++) {a=(i-m)*pi/double(n); x=R*sin(a); r=R*cos(a); if(!i?1:i==n) r=0;
	 circle3d(P+i*N,c+xyz(x,0,0),xyz(0,0,0),xyz(1,0,0),r,N);}
for(i=0;i<n;i++) seg(P+i*N,P+(i+1)*N,N); FF(P);}
/*-----*/
void yzsquare(xyz*S,xyz C,double side){int i; side/=2;
for(i=0;i<4;i++) S[i]=xyz(C.x,C.y+(i&2)?side:-side,C.z+((i+1)&2)?side:-side);}
/*-----*//* square with rounded corners */
void yzrcsquare(xyz*S,xyz C,double side,double r){int i; side/=2; xyz W[4];
float dy[16]={-2,-.5,0,0,-.5,-2,2,.5,0,0,.5,2};
float dz[12]={0,-.5,-2,2,.5,0,0,.5,2,-2,-.5,0};
yzsquare(W,C,2*side);
for(i=0;i<4;i++) {S[i+i+i]=W[i]; S[i+i+i+1]=W[i]; S[i+i+i+2]=W[i];}
for(i=0;i<12;i++) {S[i].y-=dy[i]*r; S[i].z-=dz[i]*r;}}
/*-----*/
void makemesh::cone(xyz cX,xyz cY,double r1,double r2,int N,int ends){int i;  if(!N) return;
xyz*X=FM(xyz,N),*Y=FM(xyz,N); circle3d(X,cX,cX,cY,r1,N); circle3d(Y,cY,cX,cY,r2,N);
seg(X,Y,N);
if(ends&1) for(i=0;i<N;i++) face(cX,X[i],X[(i+1)%N]);
if(ends&2) for(i=0;i<N;i++) face(cY,Y[(i+1)%N],Y[i]);
FF(X); FF(Y);}
/*-----*/
void makemesh::cylinder(xyz cX,xyz cY,double r,int N,int e){cone(cX,cY,r,r,N,e);}
/*-----*/
void makemesh::tank(xyz cX,xyz cY,double R1,double R2,int N,int ends){
N=(N+3)&0xfffc; if(N<1) return; cone(cX,cY,R1,R2,N,0);
int i,n=N/2,m=n/2; deg=atan(1.)/45; double a,x,r,pi=180*deg;
xyz c,d,*P=FM(xyz,N*(n+1)); double D=(cX-cY).r(); d=!D?cX+xyz(1,0,0):(cY-cX)/D;
if(ends&1) {
	 for(i=0;i<=m;i++) {a=(i-m)*pi/double(n); x=R1*sin(a); r=R1*cos(a); if(!i?1:i==n) r=0;
		  circle3d(P+i*N,cX+d*x,cX,cY,r,N);}
	 for(i=0;i<m;i++) seg(P+i*N,P+(i+1)*N,N);}
if(ends&2) {
	 for(i=m;i<=n;i++) {a=(i-m)*pi/double(n); x=R2*sin(a); r=R2*cos(a); if(!i?1:i==n) r=0;
		  circle3d(P+i*N,cY+d*x,cX,cY,r,N);}
	 for(i=m;i<n;i++) seg(P+i*N,P+(i+1)*N,N);}
FF(P);}
/*-----*/
void makemesh::torus(xyz c,xyz cY,double r1,double r2,int M,int N,int ib,int ie){
if(M<3?1:!N) return; int i; xyz d=cY-c,f; double r=d.rr(),p; if(!r) return;
ib=max(ib,0); ie=min(ie,M);
xyz A; circle3d(&A,c,c,cY,r1,1); double*R=FM(double,N),pi=4*atan(1.);
xyz*C=FM(xyz,16); circle3d(C,c,c,cY,r1,16); // centers of rings of vertexes
xyz*D=FM(xyz,16); circle3d(D,c,c,cY,r1/cos(2*pi/16),16); // axis markers of rings of vertexes
xyz*B=FM(xyz,N); circle3d(B,C[0],C[0],D[1],r2,N); // make a circle of vertexes
xyz*E=FM(xyz,N);
for(i=0;i<N;i++) {p=(d.x*(B[i].x-c.x)+d.y*(B[i].y-c.y)+d.z*(B[i].z-c.z))/r;
	 E[i]=c+d*p; R[i]=(E[i]-B[i]).r();}
cY=c+d*100;
xyz*X=FM(xyz,(M+1)*N);
for(i=0;i<N;i++) {circle3d(X+(M+1)*i,E[i],E[i],cY,R[i],M); X[(M+1)*i+M]=X[(M+1)*i];}
for(i=0;i<N;i++) seg(X+(M+1)*((i+1)%N)+ib,X+(M+1)*i+ib,-1-(ie-ib));
FF(B); FF(C); FF(D); FF(E); FF(X);}
/*-----*/
double ran(){return rand()/double(long(RAND_MAX));}
/*-----*/
#if 0
void makemesh::sparks(xyz c,int n,double coneht,double coner,double spw,double sph){
int i; double r,th,pi=4*atan(1.),b,e,w=spw/2; xyz B,E,P; randomize();
for(i=0;i<n;i++) {r=coner*sqrt(ran()); th=2*pi*ran(); P=xyz(r*cos(th),coneht,r*sin(th));
	 e=(coneht+sph)*ran(); b=e-sph; b=max(b,0.); e=min(e,coneht);
	 B=c-P*(b/coneht); E=c-P*(e/coneht); cone(B,E,w,w,4,2);}}
#endif
/*-----*/
xyz point(xyz*X,double N){int n=int(N); N-=n; return X[n]*(1-N)+X[n+1]*N;}
/*-----*/
int yesno(char*s,char*t) {return MessageBox(0,s,t?t:"",MB_YESNO)==IDYES;}

